// 1.11.4
/*global jQuery*/
(
  function($)
  {
    if (!$.pincette)
    {
      $.extend({pincette: {}});
    }

    $.pincette.webdav = {};
    $.pincette.webdav.dav = 'DAV:';
    $.pincette.webdav.re = 'urn:be-re:dav';
    $.pincette.webdav.ui = {};



    var ajaxCompleteHandlers = [];
    var ajaxSendHandlers = [];

    $(document).ajaxSend
    (
      function()
      {
        for (var i = 0; i < ajaxSendHandlers.length; ++i)
        {
          ajaxSendHandlers[i]();
        }
      }
    );

    $(document).ajaxComplete
    (
      function()
      {
        for (var i = 0; i < ajaxCompleteHandlers.length; ++i)
        {
          ajaxCompleteHandlers[i]();
        }
      }
    );



    var httpStatusMessages =
      {
        en:
          {
            200: 'OK.',
            201: 'Created.',
            202: 'Accepted.',
            203: 'Non-Authoritative Information.',
            204: 'No Content.',
            205: 'Reset Content.',
            206: 'Partial Content.',
            207: 'Multi Status.',
            300: 'Multiple Choices.',
            301: 'Moved Permanently.',
            302: 'Moved Temporarily.',
            303: 'See Other.',
            304: 'Not Modified.',
            305: 'The replied proxy URL is malformed.',
            400: 'Bad Request.',
            401: 'Unauthorized.',
            402: 'Payment Required.',
            403: 'Forbidden.',
            404: 'Not Found.',
            405: 'Method Not Allowed.',
            406: 'Not Acceptable.',
            407: 'Proxy Authentication Required.',
            408: 'Request Time-out.',
            409: 'Conflict.',
            410: 'Gone.',
            411: 'Length Required.',
            412: 'Precondition Failed.',
            413: 'Request Entity Too Large.',
            414: 'Request-URI Too Large.',
            415: 'Unsupported format.',
            417: 'Expectation Failed.',
            423: 'Locked.',
            500: 'Internal Server Error.',
            501: 'Not Implemented.',
            502: 'Bad Gateway.',
            503: 'Service Unavailable.',
            504: 'Gateway Time-out.',
            505: 'HTTP Version not supported.',
            506: 'Loop Detected.',
            507: 'Insufficient storage.',
            '200-checkout': 'Checked out.',
            '200-merge': 'Merged.',
            '200-uncheckout': 'Check-out reverted.',
            '201-checkin': 'Checked in.',
            '204-put': 'OK.',
            '204-unlock': 'OK.',
            '404-propfind': 'The property is not available.',
            '404-proppatch': 'The property is not available.',
            '405-checkin': 'This is not allowed.',
            '405-checkout': 'This is not allowed.',
            '405-copy': 'This is not allowed.',
            '405-delete': 'This is not allowed.',
            '405-merge': 'This is not allowed.',
            '405-mkcol': 'Already exists.',
            '405-move': 'This is not allowed.',
            '405-proppatch': 'This is not allowed.',
            '405-put': 'This is not allowed.',
            '405-uncheckout': 'This is not allowed.',
            '409-acl':
              'Protected or inherited access controls can\'t be changed.',
            '409-delete': 'There is a conflict. The resource may be in use.',
            '409-mkview': 'Already exists.',
            '409-move': 'There is a conflict. The resource may be in use.',
            '409-proppatch':
              'The property either can\'t be modified or a wrong value was given.',
            '409-put': 'Already exists (not selected?).',
            '412-copy': 'Already exists.',
            '412-move': 'Already exists.'
          },
        nl:
          {
            200: 'OK.',
            201: 'Gecre\u00eberd.',
            202: 'Aanvaard.',
            203: 'Niet-authoritaire informatie.',
            204: 'Geen inhoud.',
            205: 'Inhoud gereset.',
            206: 'Gedeeltelijke inhoud.',
            207: 'Multi Status.',
            300: 'Meerdere keuzes.',
            301: 'Definitief verplaatst.',
            302: 'Tijdelijk verplaatst.',
            303: 'Zie andere.',
            304: 'Niet gewijzigd.',
            305: 'De teruggezonden proxy-URL is ongeldig.',
            400: 'Verkeerde aanvraag.',
            401: 'Toegang ontzegd.',
            402: 'Betaling vereist.',
            403: 'Verboden.',
            404: 'Niet gevonden.',
            405: 'Methode niet toegelaten.',
            406: 'Niet aanvaardbaar.',
            407: 'Proxy-authorisatie vereist.',
            408: 'Aanvraag time-out.',
            409: 'Conflict.',
            410: 'Verdwenen.',
            411: 'Lengte vereist.',
            412: 'Preconditie onvoldaan.',
            413: 'Aanvraagentiteit te groot.',
            414: 'Aanvraag-URI te groot.',
            415: 'Niet ondersteund formaat.',
            417: 'Expectation Failed.',
            423: 'Gereserveerd.',
            500: 'Interne serverfout.',
            501: 'Niet ge\u00efmplementeerd.',
            502: 'Verkeerde gateway.',
            503: 'Dienst onbeschikbaar.',
            504: 'Gateway time-out.',
            505: 'HTTP-versie niet ondersteund.',
            506: 'Lus gedetecteerd.',
            507: 'Onvoldoende stockageruimte.',
            '200-checkout': 'Uitgecheckt.',
            '200-merge': 'Samengevoegd.',
            '200-uncheckout': 'Check-out ongedaan gemaakt.',
            '201-checkin': 'Ingecheckt.',
            '204-put': 'OK.',
            '204-unlock': 'OK.',
            '404-propfind': 'De eigenschap is niet beschikbaar.',
            '404-proppatch': 'De eigenschap is niet beschikbaar.',
            '405-checkin': 'Dit mag niet.',
            '405-checkout': 'Dit mag niet.',
            '405-copy': 'Dit mag niet.',
            '405-delete': 'Dit mag niet.',
            '405-merge': 'Dit mag niet.',
            '405-mkcol': 'Bestaat al.',
            '405-move': 'Dit mag niet.',
            '405-proppatch': 'Dit mag niet.',
            '405-put': 'Dit mag niet.',
            '405-uncheckout': 'Dit mag niet.',
            '409-acl':
              'Beschermde of ge\u00ebrfde toegangscontroles kunnen niet gewijzigd worden.',
            '409-delete':
              'Er is een conflict. Het element kan in gebruik zijn.',
            '409-mkview': 'Bestaat al.',
            '409-move': 'Er is een conflict. Het element kan in gebruik zijn.',
            '409-proppatch':
              'De eigenschap mag ofwel niet veranderd worden ofwel werd een verkeerde waarde gegeven.',
            '409-put': 'Bestaat al (niet geselecteerd?).',
            '412-copy': 'Bestaat al.',
            '412-move': 'Bestaat al.'
          }
      };

    var preconditionMessages =
      {
        en:
          {
            'activity-location-ok':
              'Activities can\'t be created in this folder.',
            'activity-must-exist': 'Only existing activities are allowed.',
            'add-must-be-new-label': 'The label is already on this version.',
            'binding-allowed': 'The resource doesn\'t support links.',
            'bind-into-collection': 'The folder doesn\'t exist.',
            'bind-source-exists': 'The resource doesn\'t exist.',
            'cannot-copy-collection-version':
              'A folder version can\'t be copied.',
            'cannot-copy-history': 'A version history can\'t be copied.',
            'cannot-merge-checked-out-resource': 'Should be checked in.',
            'cannot-modify-checked-in-parent':
              'The containing folder should be checked out.',
            'cannot-modify-destination-checked-in-parent':
              'The destination folder should be checked out.',
            'cannot-modify-protected-property':
              'The property can\'t be modified.',
            'cannot-modify-version': 'A version can\'t be modified.',
            'cannot-modify-version-controlled-content':
              'The document should be checked out.',
            'cannot-modify-version-controlled-property':
              'The document should be checked out.',
            'cannot-rename-history': 'A version history can\'t be renamed.',
            'can-overwrite': 'The name is already in use.',
            'checkin-fork-discouraged': 'Forking of versions is discouraged.',
            'checkin-fork-forbidden': 'Forking of versions is forbidden.',
            'checkout-not-allowed': 'Check-out not allowed.',
            'checkout-of-version-with-descendant-is-forbidden':
              'The selected version already has a descendant.',
            'contains-must-be-anded-at-top':
              'The "Contains" field should not occur more than once and should only be combined with the "And" operator.',
            'cross-server-binding':
              'The server doesn\'t support links to another server.',
            'cycle-allowed':
              'This link would create a loop in the folder structure.',
            'label-must-exist': 'The label is not on this version.',
            'locked-overwrite-allowed':
              'The name is in use by a locked resource.',
            'locked-source-collection-update-allowed': 'The folder is locked.',
            'locked-update-allowed': 'The folder is locked.',
            'lock-token-matches-request-uri': 'Locked.',
            'lock-token-submitted': 'Locked.',
            'merge-must-be-complete': 'The merge is not complete.',
            'must-be-checked-in': 'Not checked in.',
            'must-be-checked-out': 'Not checked out.',
            'must-be-checked-out-version-controlled-resource':
              'Not checked out.',
            'must-select-version-in-history':
              'The label doesn\'t select a version.',
            'name-allowed': 'This name is not allowed.',
            'need-privileges': 'Requires privileges.',
            'not-home': 'This is a home folder.',
            'not-supported-privilege': 'Unsupported privilege.',
            'no-invert': 'Invert is not supported.',
            'quota-not-exceeded': 'Quota exceeded.',
            'protected-source-url-deletion-allowed': 'Locked.',
            'protected-url-deletion-allowed': 'Locked.',
            'protected-url-modification-allowed':
              'The name is in use by a locked resource.',
            'rebind-into-collection': 'The folder doesn\'t exist.',
            'rebind-source-exists': 'The resource doesn\'t exist.',
            'recognized-principal': 'Unrecognized user or group.',
            'resource-must-be-null': 'Already exists.',
            'unbind-from-collection': 'The folder doesn\'t exist.',
            'unbind-source-exists': 'The resource doesn\'t exist.',
            'version-history-is-tree':
              'Predecessor versions are not in the version history.',
            'view-activity-must-be-valid':
              'A view rule should use valid activity URLs.',
            'view-activity-label-or-version':
              'A view rule should have either an activity and a label or a version name.',
            'view-label-must-be-valid':
              'A label in a view rule should be a non-empty name or the words "latest" and "checkedout".',
            'view-location-ok': 'Views can\'t be created in this collection.',
            'view-selection-path-must-be-valid':
              'A view selection path should start with a "/".',
            'view-time-for-latest-only':
              'A time may only be specified when the label is "latest".',
            'view-time-must-be-valid':
              'The time in a view rule is expressed as "yyyy-mm-ddThh:mm:ss".',
            'view-version-name-must-be-valid': 'The version name is not valid.'
          },
        nl:
          {
            'activity-location-ok':
              'Activiteiten kunnen in deze map niet gecre\u00eberd worden.',
            'activity-must-exist':
              'Alleen bestaande activiteiten zijn toegelaten.',
            'add-must-be-new-label': 'Het label staat al op deze versie.',
            'binding-allowed': 'Het document of de map ondersteunt geen links.',
            'bind-into-collection': 'De map bestaat niet.',
            'bind-source-exists': 'Het document of de map bestaat niet.',
            'cannot-copy-collection-version':
              'Een mapversie kan niet gekopieerd worden.',
            'cannot-copy-history':
              'Een versiehistoriek kan niet gekopieerd worden.',
            'cannot-merge-checked-out-resource': 'Moet ingecheckt zijn.',
            'cannot-modify-checked-in-parent':
              'De bevattende map moet uitgecheckt zijn.',
            'cannot-modify-destination-checked-in-parent':
              'De bevattende map van de bestemming moet uitgecheckt zijn.',
            'cannot-modify-protected-property':
              'De eigenschap kan niet gewijzigd worden.',
            'cannot-modify-version': 'Een versie kan niet gewijzigd worden.',
            'cannot-modify-version-controlled-content':
              'Het document moet uitgecheckt zijn.',
            'cannot-modify-version-controlled-property':
              'Het document moet uitgecheckt zijn.',
            'cannot-rename-history':
              'Een versiehistoriek kan niet hernoemd worden.',
            'can-overwrite': 'De naam is al in gebruik.',
            'checkin-fork-discouraged':
              'Een versie mag liever niet meer dan \u00e9\u00e9n volgende versie hebben.',
            'checkin-fork-forbidden':
              'Een versie mag niet meer dan \u00e9\u00e9n volgende versie hebben.',
            'checkout-not-allowed': 'Een check-out is niet toegestaan.',
            'checkout-of-version-with-descendant-is-forbidden':
              'De geselecteerde versie heeft al een volgende versie.',
            'contains-must-be-anded-at-top':
              'Het "Bevat" veld mag ten hoogste \u00e9\u00e9n maal voorkomen en mag slechts gecombineerd worden met de "En" operator.',
            'cross-server-binding':
              'De server ondersteunt geen links naar een andere server.',
            'cycle-allowed':
              'Deze link zou een lus cre\u00eberen in de mapstructuur.',
            'label-must-exist': 'Het label staat niet op deze versie.',
            'locked-overwrite-allowed':
              'De naam is in gebruik door een gereserveerd element.',
            'locked-source-collection-update-allowed':
              'De map is gereserveerd.',
            'locked-update-allowed': 'De map is gereserveerd.',
            'lock-token-matches-request-uri': 'Gereserveerd.',
            'lock-token-submitted': 'Gereserveerd.',
            'merge-must-be-complete': 'Het samenvoegen is niet voltooid.',
            'must-be-checked-in': 'Is niet ingecheckt.',
            'must-be-checked-out': 'Is niet uitgecheckt.',
            'must-be-checked-out-version-controlled-resource':
              'Is niet uitgecheckt.',
            'must-select-version-in-history':
              'Het label selecteert geen versie.',
            'name-allowed': 'Deze naam is niet toegelaten.',
            'need-privileges': 'Privileges nodig.',
            'not-home': 'Dit is een thuismap.',
            'not-supported-privilege': 'Niet ondersteund privilege.',
            'no-invert': 'Inverteren is niet ondersteund.',
            'quota-not-exceeded': 'Quota overschreden.',
            'protected-source-url-deletion-allowed': 'Gereserveerd.',
            'protected-url-deletion-allowed': 'Gereserveerd.',
            'protected-url-modification-allowed':
              'De naam is in gebruik door een gereserveerd element.',
            'rebind-into-collection': 'De map bestaat niet.',
            'rebind-source-exists': 'Het document of de map bestaat niet.',
            'recognized-principal': 'Niet herkende gebruiker of groep.',
            'resource-must-be-null': 'Bestaat al.',
            'unbind-from-collection': 'De map bestaat niet.',
            'unbind-source-exists': 'Het document of de map bestaat niet.',
            'version-history-is-tree':
              'De voorgaande versies zitten niet in de versiegeschiedenis.',
            'view-activity-must-be-valid':
              'Een viewregel moet geldige activiteits-URL\'s gebruiken.',
            'view-activity-label-or-version':
              'Een viewregel moet of een activiteit en label bevatten of een versienaam.',
            'view-label-must-be-valid':
              'Het label in een viewregel moet een niet-lege naam zijn of de woorden "latest" en "checkedout".',
            'view-location-ok':
              'Views kunnen in deze map niet gecre\u00eberd worden.',
            'view-selection-path-must-be-valid':
              'Een viewselectiepad moet met een "/" beginnen.',
            'view-time-for-latest-only':
              'Een tijdstip mag alleen gespecifieerd worden als het label "latest" is.',
            'view-time-must-be-valid':
              'De tijd in een viewregel wordt uitgedrukt als "yyyy-mm-ddThh:mm:ss".',
            'view-version-name-must-be-valid': 'De versienaam is niet geldig.'
          }
      };

    var privilegeDescriptions =
      {
        en:
          {
            'audit': 'Consult the history',
            'all': 'All operations',
            'bind': 'Add a member to a collection',
            'checkin': 'Check in a resource',
            'checkout': 'Check out a resource',
            'delete-version': 'Delete a version',
            'label': 'Manipulate labels',
            'read': 'Read',
            'read-acl': 'Consult the Access Control List',
            'read-current-user-privilege-set':
              'Consult the privilege set of the current user',
            'unbind': 'Remove a member from a collection',
            'uncheckout': 'Revert the check-out of a resource',
            'unlock': 'Unlock',
            'version': 'Version operations',
            'write': 'Write',
            'write-acl': 'Update the Access Control List',
            'write-content': 'Update the contents',
            'write-properties': 'Update the properties'
          },
        nl:
          {
            'audit': 'Geschiedenis raadplegen',
            'all': 'Alle acties',
            'bind': 'Een element aan een map toevoegen',
            'checkin': 'Een element inchecken',
            'checkout': 'Een element uitchecken',
            'delete-version': 'Een versie verwijderen',
            'label': 'Labels manipuleren',
            'read': 'Raadplegen',
            'read-acl': 'Toegangscontrolelijst raadplegen',
            'read-current-user-privilege-set':
              'Privileges van de huidige gebruiker raadplegen',
            'unbind': 'Een element uit een map verwijderen',
            'uncheckout': 'Uitchecken van een element ongedaan maken',
            'unlock': 'Reservering ongedaan maken',
            'version': 'Versieacties',
            'write': 'Wijzigen',
            'write-acl': 'Toegangscontrolelijst wijzigen',
            'write-content': 'Eigenschappen wijzigen',
            'write-properties': 'Inhoud wijzigen'
          }
      };

    var privilegeTree =
      {
        'all':
          {
            'audit': {},
            'read': {'read-version-history': {}},
            'read-acl': {},
            'read-current-user-privilege-set': {},
            'unlock': {},
            'write':
              {
                'bind': {},
                'unbind': {},
                'write-content': {},
                'write-properties': {},
                'version':
                  {
                    'checkin': {},
                    'checkout': {},
                    'delete-version': {},
                    'label': {},
                    'uncheckout': {}
                  }
              },
            'write-acl': {},
            'write-documents': {}
          }
      };

    var readPropertyActions =
      [
        {
          localName: 'acl',
          namespaceURI: $.pincette.webdav.dav,
          action: readAcl,
          field: 'acl'
        },
        {
          localName: 'auto-version',
          namespaceURI: $.pincette.webdav.dav,
          action: readAutoVersion,
          field: 'autoVersion'
        },
        {
          localName: 'bookmarks',
          namespaceURI: $.pincette.webdav.re,
          action: readBookmarks,
          field: 'bookmarks'
        },
        {
          localName: 'checked-out',
          namespaceURI: $.pincette.webdav.dav,
          action: readCheckedOut,
          field: 'checkedOut'
        },
        {
          localName: 'current-user-principal',
          namespaceURI: $.pincette.webdav.dav,
          action: readCurrentUserPrincipal,
          field: 'currentUserPrincipal'
        },
        {
          localName: 'current-user-privilege-set',
          namespaceURI: $.pincette.webdav.dav,
          action: readPrivileges,
          field: 'privileges'
        },
        {
          localName: 'fragments',
          namespaceURI: $.pincette.webdav.re,
          action: readFragments,
          field: 'fragments'
        },
        {
          localName: 'label-name-set',
          namespaceURI: $.pincette.webdav.dav,
          action: readLabelNameSet,
          field: 'labels'
        },
        {
          localName: 'home',
          namespaceURI: $.pincette.webdav.re,
          action: readHome,
          field: 'home'
        },
        {
          localName: 'lockdiscovery',
          namespaceURI: $.pincette.webdav.dav,
          action: readLockdiscovery,
          field: 'locks'
        },
        {
          localName: 'meta',
          namespaceURI: $.pincette.webdav.re,
          action: readMeta,
          field: 'meta'
        },
        {
          localName: 'parent-set',
          namespaceURI: $.pincette.webdav.dav,
          action: readParentSet,
          field: 'bindings'
        },
        {
          localName: 'preview-set',
          namespaceURI: $.pincette.webdav.dav,
          action: readPreviewSet,
          field: 'previews'
        },
        {
          localName: 'referred-by',
          namespaceURI: $.pincette.webdav.re,
          action: readRelations,
          field: 'referredBy'
        },
        {
          localName: 'referred-by-versions',
          namespaceURI: $.pincette.webdav.re,
          action: readRelations,
          field: 'referredByVersions'
        },
        {
          localName: 'referring-to',
          namespaceURI: $.pincette.webdav.re,
          action: readRelations,
          field: 'referringTo'
        },
        {
          localName: 'resourcetype',
          namespaceURI: $.pincette.webdav.dav,
          action: readResourceType,
          field: 'resourceTypes'
        },
        {
          localName: 'supported-method-set',
          namespaceURI: $.pincette.webdav.dav,
          action: readSupportedMethodSet,
          field: 'supportedMethods'
        },
        {
          localName: 'checked-in',
          namespaceURI: $.pincette.webdav.dav,
          action: readCheckedIn,
          field: 'checkedIn'
        }
      ];

    var resources =
      {
        en:
          {
            'all': 'Everybody',
            'authenticated': 'Authenticated'
          },
        fr:
          {
            'all': 'Tout le monde',
            'authenticated': 'Authentif\u00e9'
          },
        nl:
          {
            'all': 'Iedereen',
            'authenticated': 'Geauthenticeerd'
          }
      };



    function compareAce(ace1, ace2)
    {
      var result =
        !ace1.grant && ace2.grant ?
          -1 :
          (
            ace1.grant && !ace2.grant ?
              1 :
              (
                ace1.protected && !ace2.protected ?
                  -1 :
                  (
                    !ace1.protected && ace2.protected ?
                      1 :
                      (
                        !ace1.protected && ace2.protected ?
                          -1 :
                          (
                            ace1.protected && !ace2.protected ?
                              1 :
                              ace1.principal.localeCompare(ace2.principal)
                          )
                      )
                  )
              )
          );

      if (result === 0)
      {
        result =
          ace1.privilege.namespaceURI.
            localeCompare(ace2.privilege.namespaceURI);
      }

      if (result === 0)
      {
        result =
          ace1.privilege.localName.
            localeCompare(ace2.privilege.localName);
      }

      return result;
    }



    function createAcl(aces)
    {
      var result =
        '<?xml version="1.0"?><acl xmlns="' + $.pincette.webdav.dav + '">';

      for (var i = 0; i < aces.length; ++i)
      {
        result += '<ace>';

        result += aces[i].invert ? '<invert><principal>' : '<principal>';

        result +=
          $.pincette.util.url.isUrl(aces[i].principal) ||
            (
              typeof aces[i].principal === 'string' &&
                aces[i].principal.charAt(0) == '/'
            ) ?
            ('<href>' + aces[i].principal + '</href>') :
            (
              aces[i].principal instanceof Object ?
                (
                  '<property><' + aces[i].principal.localName +
                    declareXmlns(aces[i].principal.namespaceURI) +
                    '/></property>'
                ) : ('<' + aces[i].principal + '/>')
            );

        result += aces[i].invert ? '</principal><invert>' : '</principal>';

        result += '<' + (aces[i].grant ? 'grant' : 'deny') + '>';
        result += '<privilege>';

        result +=
          '<' + aces[i].privilege.localName +
            declareXmlns(aces[i].privilege.namespaceURI) + '/>';

        result += '</privilege>';
        result += '</' + (aces[i].grant ? 'grant' : 'deny') + '>';

        if (aces[i].protected)
        {
          result += '<protected/>';
        }

        result += '</ace>';
      }

      result += '</acl>';

      return result;
    }



    function createAudit(fields)
    {
      var result =
        '<?xml version="1.0"?><audit xmlns="' + $.pincette.webdav.re + '">';

      if (fields.path)
      {
        result += '<path><![CDATA[' + fields.path + ']]></path>';
      }

      if (fields.operations)
      {
        for (var i1 = 0; i1 < fields.operations.length; ++i1)
        {
          result += '<operation>' + fields.operations[i1] + '</operation>';
        }
      }

      if (fields.user)
      {
        result += '<user>' + fields.user + '</user>';
      }

      if (fields.after)
      {
        result +=
          '<after>' + $.pincette.util.timestampISO8601(fields.after) +
            '</after>';
      }

      if (fields.before)
      {
        result +=
          '<before>' + $.pincette.util.timestampISO8601(fields.before) +
            '</before>';
      }

      if (fields.count)
      {
        result += '<count/>';
      }

      if (fields.orderBy)
      {
        for (var i2 = 0; i2 < fields.orderBy.length; ++i2)
        {
          result += '<order-by>' + fields.orderBy[i2] + '</order-by>';
        }
      }

      if (fields.groupBy)
      {
        for (var i3 = 0; i3 < fields.groupBy.length; ++i3)
        {
          result += '<group-by>' + fields.groupBy[i3] + '</group-by>';
        }
      }

      if (fields.maxDuration)
      {
        result += '<max-duration/>';
      }

      if (fields.minDuration)
      {
        result += '<min-duration/>';
      }

      if (fields.avgDuration)
      {
        result += '<avg-duration/>';
      }

      if (fields.totalDuration)
      {
        result += '<total-duration/>';
      }

      result += '</audit>';

      return result;
    }



    function createBind(name, segment, href)
    {
      var result =
        '<?xml version="1.0"?><' + name + ' xmlns="' + $.pincette.webdav.dav +
          '">';

      if (segment)
      {
        result += '<segment>' + segment + '</segment>';
      }

      if (href)
      {
        result += '<href><![CDATA[' + href + ']]></href>';
      }

      result += '</' + name + '>';

      return result;
    }



    function createBookmarks(bookmarks)
    {
      var result =
        '<set><prop><bookmarks xmlns="' + $.pincette.webdav.re + '">';

      for (var i = 0; i < bookmarks.length; ++i)
      {
        result +=
          '<bookmark><name><![CDATA[' + bookmarks[i].name + ']]></name>';
        result +=
          '<href><![CDATA[' + bookmarks[i].href + ']]></href></bookmark>';
      }

      result += '</bookmarks></prop></set>';

      return result;
    }



    function createCheckedIn()
    {
      return '<?xml version="1.0"?><expand-property xmlns="' +
        $.pincette.webdav.dav +
        '"><property name="checked-in"><property name="creator-displayname"/>' +
        '<property name="comment"/></property></expand-property>';
    }



    function createError(propstat, method)
    {
      var result = {};

      result.prop =
        $.pincette.util.dom.getQName
        (
          $.pincette.util.dom.selectFirstElement
          (
            $.pincette.util.dom.
              selectFirstElement(propstat, 'prop', $.pincette.webdav.dav)
          )
        );

      result.error = getErrorElement(propstat);
      result.status = getStatusCode(propstat);

      result.responseDescription =
        $.pincette.util.dom.selectFirstElement
        (
          propstat,
          'responsedescription',
          $.pincette.webdav.dav
        );

      result.message =
        $.pincette.webdav.ui.report
        (
          method,
          result.status,
          result.error,
          result.responseDescrpition
        );

      return result;
    }



    function createExpression(expression)
    {
      var result = '<expr>';

      if (expression.op == 'and' || expression.op == 'or')
      {
        result += '<' + expression.op + '>';

        for (var i = 0; i < expression.expressions.length; ++i)
        {
          result += createExpression(expression.expressions[i]);
        }

        result += '</' + expression.op + '>';
      }
      else
      {
        result += '<field><![CDATA[' + expression.field + ']]></field>';
        result += '<op><![CDATA[' + expression.op + ']]></op>';
        result += '<value><![CDATA[' + expression.value + ']]></value>';
      }

      result += '</expr>';

      return result;
    }



    function createLabel(label, operation)
    {
      var result =
        '<?xml version="1.0"?><label xmlns="' + $.pincette.webdav.dav +
          '"><' + operation + '><label-name>' + label + '</label-name></' +
          operation + '></label>';

      return result;
    }



    function createLockinfo(properties)
    {
      var result =
        '<?xml version="1.0"?><lockinfo xmlns="' + $.pincette.webdav.dav + '">';

      result += '<lockscope><exclusive/></lockscope>';
      result += '<locktype><write/></locktype>';
      result += '</lockinfo>';

      return result;
    }



    function createMeta(meta)
    {
      var result = '<set><prop><meta xmlns="' + $.pincette.webdav.re + '">';

      for (var metaName in meta)
      {
        if (meta.hasOwnProperty(metaName))
        {
          for (var i = 0; i < meta[metaName].length; ++i)
          {
            var label = $.pincette.util.dc.getLabel(metaName);

            if (!label)
            {
              label = metaName;
            }

            result += '<prop><name><![CDATA[' + label + ']]></name>';
            result +=
              '<value><![CDATA[' + meta[metaName][i] + ']]></value></prop>';
          }
        }
      }

      result += '</meta></prop></set>';

      return result;
    }



    function createPropfind(properties)
    {
      var result =
        '<?xml version="1.0"?><propfind xmlns="' + $.pincette.webdav.dav + '">';

      if (properties === undefined)
      {
        result += '<propname/>';
      }
      else
      {
        if (properties.length === 0)
        {
          result += '<allprop/>';
        }
        else
        {
          result += '<prop>';

          for (var i = 0; i < properties.length; ++i)
          {
            result +=
              '<' + properties[i].localName +
                declareXmlns(properties[i].namespaceURI) + '/>';
          }

          result += '</prop>';
        }
      }

      result += '</propfind>';

      return result;
    }



    function createProppatch(properties)
    {
      var result =
        '<?xml version="1.0"?><propertyupdate xmlns="' + $.pincette.webdav.dav +
          '" xmlns:re="' + $.pincette.webdav.re + '">';

      for (var name in properties)
      {
        if (name == 'meta')
        {
          result += createMeta(properties.meta);
        }
        else
        {
          if (name == 'referringTo')
          {
            result += createReferringTo(properties.referringTo);
          }
          else
          {
            if (name == 'bookmarks')
            {
              result += createBookmarks(properties.bookmarks);
            }
            else
            {
              result += '<set><prop>';
              result +=
                '<' + name.replace(/re_/, 're:') + '><![CDATA[' +
                  properties[name] + ']]></' + name.replace(/re_/, 're:') + '>';
              result += '</prop></set>';
            }
          }
        }
      }

      result += '</propertyupdate>';

      return result;
    }



    function createReferringTo(referringTo)
    {
      var result =
        '<set><prop><referring-to xmlns="' + $.pincette.webdav.re + '">';

      for (var i = 0; i < referringTo.length; ++i)
      {
        result += '<relation><name>' + referringTo[i].name + '</name>';
        result +=
          '<href><![CDATA[' + referringTo[i].href + ']]></href></relation>';
      }

      result += '</referring-to></prop></set>';

      return result;
    }



    function createSearch(expressions, properties)
    {
      var result =
        '<?xml version="1.0"?><simple-search xmlns="' + $.pincette.webdav.re +
          '">';

      if (expressions.length > 1)
      {
        result += '<and>';
      }

      for (var i = 0; i < expressions.length; ++i)
      {
        result += createExpression(expressions[i]);
      }

      if (expressions.length > 1)
      {
        result += '</and>';
      }

      if (properties.length > 0)
      {
        result += '<prop xmlns="' + $.pincette.webdav.dav + '">';

        for (i = 0; i < properties.length; ++i)
        {
          result +=
            '<' + properties[i].localName +
              declareXmlns(properties[i].namespaceURI) + '/>';
        }

        result += '</prop>';
      }

      result += '</simple-search>';

      return result;
    }



    function createVersionRequest(properties)
    {
      var result =
        '<?xml version="1.0"?><expand-property xmlns="' +
          $.pincette.webdav.dav +
          '"><property name="version-history"><property name="version-set">';

      for (var i = 0; i < properties.length; ++i)
      {
        result +=
          '<property name="' + properties[i].localName + '"' +
            (
              properties[i].namespaceURI != $.pincette.webdav.dav ?
                (' namespace="' + properties[i].namespaceURI + '"') : ''
            ) + '/>';
      }

      result += '</property></property></expand-property>';

      return result;
    }



    function declareXmlns(namespaceURI)
    {
      var result =
        $.pincette.webdav.dav != namespaceURI ?
          (' xmlns="' + (namespaceURI ? namespaceURI : '') + '"') : '';

      return result;
    }



    function displayFields(field, values, fields)
    {
      var result = [];

      for (var i = 0; i < values.length; ++i)
      {
        if (fields[field])
        {
          if (fields[field].type == 'date')
          {
            result.push
            (
              $.pincette.util.
                displayDate($.pincette.util.parseISO8601(values[i]))
 
            );
          }
          else
          {
            if (fields[field].type == 'time')
            {
              result.push
              (
                displayTime($.pincette.util.parseISO8601(values[i]))
              );
            }
            else
            {
              result.push(fieldValue(values[i]));
            }
          }
        }
        else
        {
          result.push(fieldValue(values[i]));
        }
      }

      return result;
    }



    function displayFieldsWithType(data, fields)
    {
      for (var i in data)
      {
        if (fields[i] && fields[i].type)
        {
          if (data[i] instanceof Date)
          {
            data[i] =
              fields[i].type == 'date' ?
                $.pincette.util.displayDate(data[i]) :
                (fields[i].type == 'time' ? displayTime(data[i]) : data[i]);
          }
          else
          {
            if (fields[i].type == 'number' && $.pincette.util.isNumber(data[i]))
            {
              data[i] =
                Number(data[i]).toLocaleString($.pincette.util.getLocale());
            }
          }
        }
      }
    }



    function displayMeta(data, meta, fields)
    {
      for (var i in meta)
      {
        if (meta.hasOwnProperty(i))
        {
          var values = displayFields(i, meta[i], fields);

          if (values.length > 0)
          {
            if (values[0].documentElement)
            {
              var doc = $.parseXML('<div></div>');

              for (var j = 0; j < values.length; ++j)
              {
                $(doc.documentElement).append(values[j].documentElement);
              }

              try
              {
                data[i] =
                  new XMLSerializer().serializeToString(doc.documentElement);
              }

              catch (e)
              {
                data[i] = doc.documentElement.xml; // IE8
              }
            }
            else
            {
              data[i] = $.pincette.util.addWrapPoints(values.join(', '));
            }
          }
          else
          {
            data[i] = '';
          }
        }
      }
    }



    function displayNumberFields(data, fields)
    {
      for (var i in data)
      {
        if (data[i] instanceof Number)
        {
          data[i] = data[i].toLocaleString($.pincette.util.getLocale());
        }
      }
    }



    function displayRelations(response, relations, name)
    {
      if (relations.length === 0)
      {
        return '';
      }

      if (response.relationTitles === null)
      {
        response.relationTitles = {};
      }

      var result = '';

      for (var i = 0; i < relations.length; ++i)
      {
        if (name == relations[i].name)
        {
          result +=
            '<div class="pincette-relation"><span>' +
              '<a target="_blank" href="' + relations[i].href + '">' +
              (
                response.relationTitles[relations[i].href] ?
                  response.relationTitles[relations[i].href] : ''
              ) + '</a></span></div>';
        }
      }

      return result;
    }



    function displayTime(time)
    {
      var result =
        $.pincette.util.displayDate(time) + '\u00a0' +
          $.pincette.util.displayTime(time);

      return result;
    }



    function getErrorElement(element)
    {
      var error =
        $.pincette.util.dom.
          selectFirstElement(element, 'error', $.pincette.webdav.dav);

      if (!error)
      {
        var errors =
          $.pincette.util.dom.selectPath
          (
            element,
            [
              {
                namespaceURI: $.pincette.webdav.dav,
                localName: 'responsedescription'
              },
              {
                namespaceURI: $.pincette.webdav.dav,
                localName: 'error'
              }
            ]
          );

        if (errors.length > 0)
        {
          $.pincette.util.dom.clearNode
          (
            $.pincette.util.dom.selectFirstElement
            (
              element,
              'responsedescription',
              $.pincette.webdav.dav
            )
          );

          error = errors[0];
        }
      }

      return error;
    }



    function getPropertyAction(name)
    {
      for (var i = 0; i < readPropertyActions.length; ++i)
      {
        if
        (
          name.localName == readPropertyActions[i].localName		&&
          name.namespaceURI == readPropertyActions[i].namespaceURI
        )
        {
          return readPropertyActions[i];
        }
      }

      return null;
    }



    function fieldValue(value)
    {
      try
      {
        var doc = $.parseXML(value.replace(/&/g, '&amp;'));
        var result =
          doc && doc.documentElement &&
            doc.documentElement.localName != 'html' ?
            doc : value;

        return result;
      }

      catch (e)
      {
        var result =
          value.replace(/<[A-Za-z_:][A-Za-z0-9\.\-_:]*>/g, '').
            replace(/<\/[A-Za-z_:][A-Za-z0-9\.\-_:]*>/g, '');

        return result;
      }
    }



    function findPrivilege(tree, name)
    {
      for (var privilege in tree)
      {
        if (tree.hasOwnProperty(privilege))
        {
          var result =
            privilege == name ?
              tree[privilege] : findPrivilege(tree[privilege], name);

          if (result)
          {
            return result;
          }
        }
      }

      return null;
    }



    function getHeaders(httpResponse)
    {
      var headers = getLines(httpResponse.getAllResponseHeaders());
      var result = {};

      for (var i = 0; i < headers.length; ++i)
      {
        var index = headers[i].indexOf(': ');

        if (index != -1)
        {
          var name = headers[i].substring(0, index).trim().toLowerCase();

          if (!result[name])
          {
            result[name] = [];
          }

          result[name].push(headers[i].substring(index + 2).trim());
        }
      }

      return result;
    }



    function getHref(url, element)
    {
      var result =
        resolveUrl
        (
          url,
          $.pincette.util.dom.getText
          (
            $.pincette.util.dom.selectFirstElement
            (
              element,
              'href',
              element.namespaceURI
            )
          )
        );

      return result;
    }



    function getLines(s)
    {
      var position = 0;
      var result = [];

      for (var i = s.indexOf('\r\n'); i != -1; i = s.indexOf('\r\n', i + 2))
      {
        result.push(s.substring(position, i));
        position = i + 2;
      }

      return result;
    }



    function getPreview(response)
    {
      if (!response.previews)
      {
        return null;
      }

      var href = null;
      var smallest = 0;

      for (var i = 0; i < response.previews.length; ++i)
      {
        var width1 = Number(response.previews[i].width);

        if (width1 >= 128 && (smallest === 0 || width1 < smallest))
        {
          href = response.previews[i].href;
          smallest = width1;
        }
      }

      if (!href)
      {
        var largest = 0;

        for (i = 0; i < response.previews.length; ++i)
        {
          var width2 = Number(response.previews[i].width);

          if (width2 > largest)
          {
            href = response.previews[i].href;
            largest = width2;
          }
        }
      }

      return href;
    }



    function getPrincipal(href, principal)
    {
      var element = $.pincette.util.dom.selectFirstElement(principal);
      var result;

      if (element.namespaceURI && element.namespaceURI != $.pincette.webdav.dav)
        // There are no namespaces in IE < 9.
      {
        result = null;
      }
      else
      {
        var name = $.pincette.util.dom.getLocalName(element);

        if ('href' == name)
        {
          result = resolveUrl(href, $.pincette.util.dom.getText(element));
        }
        else
        {
          if ('property' == name)
          {
            var property = $.pincette.util.dom.selectFirstElement(element);

            if (property !== null)
            {
              result =
                {
                  namespaceURI: property.namespaceURI,
                  localName: $.pincette.util.dom.getLocalName(property)
                };
            }
          }
          else
          {
            result = name;
          }
        }
      }

      return result;
    }



    function getResource(key)
    {
      var map =
        $.pincette.util.perLanguage(resources, $.pincette.util.getLocale());
      var value = map[key];
      var result = value ? value : key;

      return result;
    }



    function getStableHref(response, contextPath)
    {
      var value = $.pincette.webdav.getMetaDataValue(response, 'dc_identifier');

      if (value)
      {
        var url = $.pincette.util.url.getParts(response.href);
        var result =
          (
            url && url.scheme ?
              (
                url.scheme + "://" +
                  (url.host ? encodeURIComponent(url.host) : '') +
                  (url.port ? (':' + url.port) : '')
              ) : ''
          ) + (contextPath ? contextPath : '') +
            '/meta/properties/dc-identifier/' + encodeURIComponent(value);

        return result;
      }

      return null;
    }



    function getStablePreviewHref(response, href, contextPath)
    {
      var parameters = $.pincette.util.url.getParameters(href);
      var stableHref = getStableHref(response, contextPath);
      var result =
        parameters.preview && stableHref ?
          (stableHref + '?preview=' + parameters.preview[0]) : null;

      return result;
    }



    function getStatusCode(element)
    {
      var statusLine =
        $.pincette.util.dom.getText
        (
          $.pincette.util.dom.
            selectFirstElement(element, 'status', $.pincette.webdav.dav)
        );

      if (!statusLine)
      {
        return -1;
      }

      statusLine = statusLine.trim();

      var result =
        statusLine.indexOf('HTTP/1.0 ') === 0 ||
          statusLine.indexOf('HTTP/1.1 ') === 0 ?
          statusLine.substring(9, statusLine.indexOf(' ', 9)) : -1;

      return result;
    }



    function getUrlPath(url)
    {
      var parts = $.pincette.util.url.getParts(url);
      var result = parts === null ? url : parts.path;

      return result;
    }



    function impliesPrivilege(given, requested)
    {
      var tree = findPrivilege(privilegeTree, given);

      return tree && findPrivilege(tree, requested) !== null;
    }



    function lazyLoadRelations(response, text, data, done, dav)
    {
      var properties = [];
      var referredBy = text.match(/\$\[(referredBy(:([a-zA-Z]+))?)\]/);
      var referredByVersions =
        text.match(/\$\[(referredByVersions(:([a-zA-Z]+))?)\]/);
      var referringTo = text.match(/\$\[(referringTo(:([a-zA-Z]+))?)\]/);

      if (!response.referringTo && referringTo)
      {
        properties.
          push({namespaceURI: $.pincette.webdav.re, localName: 'referring-to'});
      }

      if (!response.referredBy && referredBy)
      {
        properties.
          push({namespaceURI: $.pincette.webdav.re, localName: 'referred-by'});
      }

      if (!response.referredByVersions && referredByVersions)
      {
        properties.push
        (
          {
            namespaceURI: $.pincette.webdav.re,
            localName: 'referred-by-versions'
          }
        );
      }

      dav.startChaining();

      if (properties.length > 0)
      {
        dav.getProperties
        (
          response.href,
          properties,
          function(resp)
          {
            if (referringTo)
            {
              response.referringTo = resp.referringTo ? resp.referringTo : [];
            }

            if (referredBy)
            {
              response.referredBy = resp.referredBy ? resp.referredBy : [];
            }

            if (referredByVersions)
            {
              response.referredByVersions =
                resp.referredByVersions ? resp.referredByVersions : [];
            }

            loadAllRelationTitles(dav, response);
          }
        );
      }
      else
      {
        if (referringTo || referredBy || referredByVersions)
        {
          loadAllRelationTitles(dav, response);
        }
      }

      dav.runChain
      (
        function()
        {
          if (response.referredBy && referredBy)
          {
            data[referredBy[1]] =
              displayRelations(response, response.referredBy, referredBy[3]);
          }

          if (response.referredByVersions && referredByVersions)
          {
            data[referredByVersions[1]] =
              displayRelations
              (
                response,
                response.referredByVersions,
                referredByVersions[3]
              );
          }

          if (response.referringTo && referringTo)
          {
            data[referringTo[1]] =
              displayRelations(response, response.referringTo, referringTo[3]);
          }

          if (done)
          {
            done(data);
          }
        }
      );
    }



    function loadAllRelationTitles(dav, response)
    {
      if (!response.relationTitles)
      {
        response.relationTitles = {};
      }

      if (response.referringTo)
      {
        loadRelationTitles(dav, response, response.referringTo);
      }

      if (response.referredBy)
      {
        loadRelationTitles(dav, response, response.referredBy);
      }

      if (response.referredByVersions)
      {
        loadRelationTitles(dav, response, response.referredByVersions);
      }
    }



    function loadRelationTitles(dav, response, relations)
    {
      function done(resp)
      {
        response.relationTitles[resp.href] =
          resp.meta.dc_title && resp.meta.dc_title.length > 0 ?
          resp.meta.dc_title[0] :
          $.pincette.util.addWrapPoints(resp.href);
      }

      for (var i = 0; i < relations.length; ++i)
      {
        if (!response.relationTitles[relations[i].href])
        {
          dav.getProperties
          (
            relations[i].href,
            [{namespaceURI: $.pincette.webdav.re, localName: 'meta'}],
            done
          );
        }
      }
    }



    function processMultistatus
    (
      url,
      responseText,
      method,
      includeSelf,
      contextPath,
      success,
      failure
    )
    {
      processResponses
      (
        url,
        $.pincette.util.dom.selectElements
        (
          $.parseXML(responseText).documentElement,
          'response',
          $.pincette.webdav.dav
        ),
        method,
        includeSelf,
        contextPath,
        success,
        failure
      );
    }



    function processResponse
    (
      url,
      response,
      method,
      includeSelf,
      contextPath,
      success,
      failure
    )
    {
      var error = getErrorElement(response);
      var status = getStatusCode(response);

      if (!error && status < 400 && success)
      {
        var resp = readResponse(url, response, method, contextPath);

        if (resp.errors && failure)
        {
          for (var i = 0; i < resp.errors.length; ++i)
          {
            failure
            (
              getHref(url, response),
              resp.errors[i].status,
              method,
              resp.errors[i].error,
              resp.errors[i].responseDescription
            );
          }
        }

        if
        (
          includeSelf						||
          resp.href != resolveUrl(window.location.href, url)
        )
        {
          success(resp);
        }
      }
      else
      {
        if ((error || status >= 400) && failure)
        {
          failure
          (
            getHref(url, response),
            status,
            method,
            error,
            $.pincette.util.dom.selectFirstElement
            (
              response,
              'responsedescription',
              $.pincette.webdav.dav
            )
          );
        }
      }
    }



    function processResponses
    (
      url,
      responses,
      method,
      includeSelf,
      contextPath,
      success,
      failure
    )
    {
      for (var i = 0; i < responses.length; ++i)
      {
        processResponse
        (
          url,
          responses[i],
          method,
          includeSelf,
          contextPath,
          success,
          failure
        );
      }
    }



    function processVersionSet(url, responseText, contextPath, success, failure)
    {
      processResponses
      (
        url,
        $.pincette.util.dom.selectPath
        (
          $.parseXML(responseText).documentElement,
          [
            {namespaceURI: $.pincette.webdav.dav, localName: 'response'},
            {namespaceURI: $.pincette.webdav.dav, localName: 'propstat'},
            {namespaceURI: $.pincette.webdav.dav, localName: 'prop'},
            {namespaceURI: $.pincette.webdav.dav, localName: 'version-history'},
            {namespaceURI: $.pincette.webdav.dav, localName: 'response'},
            {namespaceURI: $.pincette.webdav.dav, localName: 'propstat'},
            {namespaceURI: $.pincette.webdav.dav, localName: 'prop'},
            {namespaceURI: $.pincette.webdav.dav, localName: 'version-set'},
            {namespaceURI: $.pincette.webdav.dav, localName: 'response'}
          ]
        ),
        'REPORT',
        true,
        contextPath,
        success,
        failure
      );
    }



    function readAcl(response, field, acl)
    {
      var aces =
        $.pincette.util.dom.selectElements(acl, 'ace', $.pincette.webdav.dav);
      var result = [];

      for (var i = 0; i < aces.length; ++i)
      {
        var ace = {};
        var principal =
          $.pincette.util.dom.
            selectFirstElement(aces[i], 'principal', $.pincette.webdav.dav);
        var privileges =
          $.pincette.util.dom.selectPath
          (
            aces[i],
            [
              {namespaceURI: $.pincette.webdav.dav, localName: 'grant'},
              {namespaceURI: $.pincette.webdav.dav, localName: 'privilege'}
            ]
          );

        ace.invert = (principal === null);
        ace.protected =
          (
            $.pincette.util.dom.selectFirstElement
            (
              aces[i],
              'protected',
              $.pincette.webdav.dav
            ) !== null
          );
        ace.grant = (privileges.length > 0);

        if (principal === null)
        {
          var principals =
            $.pincette.util.dom.selectPath
            (
              aces[i],
              [
                {namespaceURI: $.pincette.webdav.dav, localName: 'invert'},
                {namespaceURI: $.pincette.webdav.dav, localName: 'principal'}
              ]
            );

          if (principals.length > 0)
          {
            principal = principals[0];
          }
        }

        if (principal !== null)
        {
          ace.principal = getPrincipal(response.href, principal);

          if (privileges.length === 0)
          {
            privileges =
              $.pincette.util.dom.selectPath
              (
                aces[i],
                [
                  {namespaceURI: $.pincette.webdav.dav, localName: 'deny'},
                  {namespaceURI: $.pincette.webdav.dav, localName: 'privilege'}
                ]
              );
          }

          for (var j = 0; j < privileges.length; ++j)
          {
            var elements = $.pincette.util.dom.selectElements(privileges[j]);

            if (elements.length == 1)
            {
              var copy = $.pincette.util.copy(ace);

              copy.privilege = {};
              copy.privilege.localName =
                $.pincette.util.dom.getLocalName(elements[0]);
              copy.privilege.namespaceURI = elements[0].namespaceURI;
              result.push(copy);
            }
          }
        }
      }

      response[field] = result;
    }



    function readAutoVersion(response, field, autoVersion)
    {
      var element = $.pincette.util.dom.selectFirstElement(autoVersion);

      response[field] =
        element ? $.pincette.util.dom.getLocalName(element) : 'manual';
    }



    function readBookmarks(response, field, bookmarks)
    {
      var bookmarkElements =
        $.pincette.util.dom.
          selectElements(bookmarks, 'bookmark', $.pincette.webdav.re);
      var result = [];

      for (var i = 0; i < bookmarkElements.length; ++i)
      {
        result.push
        (
          {
            name:
              $.pincette.util.dom.getText
              (
                $.pincette.util.dom.selectFirstElement
                (
                  bookmarkElements[i],
                  'name',
                  $.pincette.webdav.re
                )
              ),
            href:
              $.pincette.util.dom.getText
              (
                $.pincette.util.dom.selectFirstElement
                (
                  bookmarkElements[i],
                  'href',
                  $.pincette.webdav.re
                )
              )
          }
        );
      }

      result.sort
      (
        function(b1, b2)
        {
          return b1.name.toLowerCase().localeCompare(b2.name.toLowerCase());
        }
      );

      response[field] = result;
    }



    function readCheckedIn(response, field, checkedIn)
    {
      var result = {};

      var href =
        $.pincette.util.dom.selectPath
        (
          checkedIn,
          [
            {namespaceURI: $.pincette.webdav.dav, localName: 'response'},
            {namespaceURI: $.pincette.webdav.dav, localName: 'href'}
          ]
        );

      if (href.length === 1)
      {
        result.href = $.pincette.util.dom.getText(href[0]);
      }

      var prop =
        $.pincette.util.dom.selectPath
        (
          checkedIn,
          [
            {namespaceURI: $.pincette.webdav.dav, localName: 'response'},
            {namespaceURI: $.pincette.webdav.dav, localName: 'propstat'},
            {namespaceURI: $.pincette.webdav.dav, localName: 'prop'}
          ]
        );

      if (prop.length === 1)
      {
        result.comment =
          $.pincette.util.dom.getText
          (
            $.pincette.util.dom.
              selectFirstElement(prop[0], 'comment', $.pincette.webdav.dav)
          );
        result.creatorDisplayname =
          $.pincette.util.dom.getText
          (
            $.pincette.util.dom.selectFirstElement
            (
              prop[0],
              'creator-displayname',
              $.pincette.webdav.dav
            )
          );
      }

      response[field] = result;
    }



    function readCheckedOut(response, field, checkedOut)
    {
      response[field] = true;
    }



    function readCurrentUserPrincipal(response, field, currentUserPrincipal)
    {
      var href=
        $.pincette.util.dom.selectFirstElement
        (
          currentUserPrincipal,
          'href',
          $.pincette.webdav.dav
        );

      if (href)
      {
        response[field] = $.pincette.util.dom.getText(href);
      }
    }



    function readEvents(events)
    {
      var result = [];

      for (var i = 0; i < events.length; ++i)
      {
        result.push($.pincette.util.dom.toJson(events[i]));
      }

      return result;
    }



    function readFragments(response, field, fragments)
    {
      var elements = $.pincette.util.dom.selectElements(fragments);
      var result = '';

      for (var i = 0; i < elements.length; ++i)
      {
        if (result.length > 0)
        {
          result += ' ... ';
        }

        for (var n = elements[i].firstChild; n; n = n.nextSibling)
        {
          if (n.nodeType == 3)
          {
            result += n.data;
          }
          else
          {
            if ($.pincette.util.dom.getLocalName(n) == 'term')
            {
              result +=
                '<span class="term">' +
                  $.pincette.util.
                    escapeXMLText($.pincette.util.dom.getText(n)) + '</span>';
            }
          }
        }
      }

      response.fragments = result;
    }



    function readHome(response, field, home)
    {
      response.home =
        resolveUrl(response.href, $.pincette.util.dom.getText(home));
    }



    function readLabelNameSet(response, field, labelNameSet)
    {
      var labels =
        $.pincette.util.dom.
          selectElements(labelNameSet, 'label-name', $.pincette.webdav.dav);
      var result = [];

      for (var i = 0; i < labels.length; ++i)
      {
        result.push($.pincette.util.dom.getText(labels[i]));
      }

      response[field] = result;
    }



    function readLockdiscovery(response, field, lockdiscovery)
    {
      response[field] = readLockdiscoveryNode(lockdiscovery);
    }



    function readLockdiscoveryNode(lockdiscovery)
    {
      var locks =
        $.pincette.util.dom.
          selectElements(lockdiscovery, 'activelock', $.pincette.webdav.dav);
      var result = [];

      for (var i = 0; i < locks.length; ++i)
      {
        var lock = {};
        var scope =
          $.pincette.util.dom.
            selectFirstElement(locks[i], 'lockscope', $.pincette.webdav.dav);

        if (scope)
        {
          lock.scope =
            $.pincette.util.dom.
              getLocalName($.pincette.util.dom.selectFirstElement(scope));
        }

        var type =
          $.pincette.util.dom.
            selectFirstElement(locks[i], 'locktype', $.pincette.webdav.dav);

        if (type)
        {
          lock.type =
            $.pincette.util.dom.
              getLocalName($.pincette.util.dom.selectFirstElement(type));
        }

        var depth =
          $.pincette.util.dom.getText
          (
            $.pincette.util.dom.
              selectFirstElement(locks[i], 'depth', $.pincette.webdav.dav)
          );

        if (depth)
        {
          lock.depth = depth;
        }

        var owner =
          $.pincette.util.dom.
            selectFirstElement(locks[i], 'owner', $.pincette.webdav.dav);

        if (owner)
        {
          var href=
            $.pincette.util.dom.
              selectFirstElement(owner, 'href', $.pincette.webdav.dav);

          lock.owner =
            href ?
              $.pincette.util.
                getLastPathSegment($.pincette.util.dom.getText(href)) :
              $.pincette.util.dom.getText(owner);
        }

        var timeout =
          $.pincette.util.dom.getText
          (
            $.pincette.util.dom.
              selectFirstElement(locks[i], 'timeout', $.pincette.webdav.dav)
          );

        if (timeout)
        {
          lock.timeout = timeout;
        }

        var tokens =
          $.pincette.util.dom.selectPath
          (
            locks[i],
            [
              {
                namespaceURI: $.pincette.webdav.dav,
                localName: 'locktoken'
              },
              {
                namespaceURI: $.pincette.webdav.dav,
                localName: 'href'
              }
            ]
          );

        if (tokens.length == 1)
        {
          lock.token = $.pincette.util.dom.getText(tokens[0]);
        }

        var root =
          $.pincette.util.dom.getText
          (
            $.pincette.util.dom.selectPath
            (
              locks[i],
              [
                {
                  namespaceURI: $.pincette.webdav.dav,
                  localName: 'lockroot'
                },
                {
                  namespaceURI: $.pincette.webdav.dav,
                  localName: 'href'
                }
              ]
            )
          );

        if (root)
        {
          lock.root = root;
        }

        result.push(lock);
      }

      return result;
    }



    function readMeta(response, field, meta)
    {
      var props =
        $.pincette.util.dom.selectElements(meta, 'prop', $.pincette.webdav.re);
      var result = {};

      for (var i = 0; i < props.length; ++i)
      {
        var name =
          $.pincette.util.dom.getText
          (
            $.pincette.util.dom.
              selectFirstElement(props[i], 'name', $.pincette.webdav.re)
          );
        var term = $.pincette.util.dc.getElementOrTerm(name);

        if (term)
        {
          name = term;
        }

        if (!result[name])
        {
          result[name] = [];
        }

        result[name].push
        (
          $.pincette.util.dom.getText
          (
            $.pincette.util.dom.
              selectFirstElement(props[i], 'value', $.pincette.webdav.re)
          )
        );
      }

      for (i in result)
      {
        if (result.hasOwnProperty(i))
        {
          result[i].sort();
        }
      }

      response[field] = result;
    }



    function readParentSet(response, field, parentSet)
    {
      var parents =
        $.pincette.util.dom.
          selectElements(parentSet, 'parent', $.pincette.webdav.dav);
      var result = [];

      for (var i = 0; i < parents.length; ++i)
      {
        var href = getHref(response.href, parents[i]);

        result.push
        (
          href + ($.pincette.util.endsWith(href, '/') ? '' : '/') +
            encodeURIComponent
            (
              $.pincette.util.dom.getText
              (
                $.pincette.util.dom.selectFirstElement
                (
                  parents[i],
                  'segment',
                  $.pincette.webdav.dav
                )
              )
            )
        );
      }

      response[field] = result;
    }



    function readPreviewSet(response, field, previewSet, contextPath)
    {
      var previews =
        $.pincette.util.dom.
          selectElements(previewSet, 'preview', $.pincette.webdav.dav);
      var result = [];

      for (var i = 0; i < previews.length; ++i)
      {
        var foundHref = getHref(response.href, previews[i]);

        result.push
        (
          {
            href: foundHref,
            stableHref: getStablePreviewHref(response, foundHref, contextPath),
            mimeType:
              $.pincette.util.dom.getText
              (
                $.pincette.util.dom.selectFirstElement
                (
                  previews[i],
                  'mime-type',
                  $.pincette.webdav.dav
                )
              ),
            width:
              $.pincette.util.dom.getText
              (
                $.pincette.util.dom.selectFirstElement
                (
                  previews[i],
                  'width',
                  $.pincette.webdav.dav
                )
              ),
            height:
              $.pincette.util.dom.getText
              (
                $.pincette.util.dom.selectFirstElement
                (
                  previews[i],
                  'height',
                  $.pincette.webdav.dav
                )
              )
          }
        );
      }

      response[field] = result;
    }



    function readPrivileges(response, field, privilegeSet)
    {
      var privileges =
        $.pincette.util.dom.
          selectElements(privilegeSet, 'privilege', $.pincette.webdav.dav);
      var result = [];

      for (var i = 0; i < privileges.length; ++i)
      {
        var element = $.pincette.util.dom.selectFirstElement(privileges[i]);

        if (element)
        {
          result.push($.pincette.util.dom.getLocalName(element));
        }
      }

      response[field] = result;
    }



    function readRelations(response, field, refer)
    {
      var relations =
        $.pincette.util.dom.
          selectElements(refer, 'relation', $.pincette.webdav.re);
      var result = [];

      for (var i = 0; i < relations.length; ++i)
      {
        var relation = {};

        relation.name =
          $.pincette.util.dom.getText
          (
            $.pincette.util.dom.
              selectFirstElement(relations[i], 'name', $.pincette.webdav.re)
          );
        relation.href = getHref(response.href, relations[i]);
        result.push(relation);
      }

      response[field] = result;
    }



    function readResourceType(response, field, resourceType)
    {
      var elements = $.pincette.util.dom.selectElements(resourceType);

      response[field] = [];
      response.isCollection = false;

      for (var i = 0; i < elements.length; ++i)
      {
        var name = $.pincette.util.dom.getLocalName(elements[i]);

        response[field].push(name);

        if (name == 'collection')
        {
          response.isCollection = true;
        }
      }

      if (response[field].length === 0)
      {
        response[field].push('document');
      }
    }



    function readResponse(url, response, method, contextPath)
    {
      var propstats =
        $.pincette.util.dom.
          selectElements(response, 'propstat', $.pincette.webdav.dav);
      var result = {};

      result.href = getHref(url, response);
      result.name =
        decodeURIComponent($.pincette.util.getLastPathSegment(result.href));
      result.checkedOut = false;

      for (var i = 0; i < propstats.length; ++i)
      {
        var code = getStatusCode(propstats[i]);

        if (code == '200')
        {
          var props =
            $.pincette.util.dom.selectElements
            (
              $.pincette.util.dom.selectFirstElement(propstats[i])
            );

          for (var j = 0; j < props.length; ++j)
          {
            var action =
              getPropertyAction($.pincette.util.dom.getQName(props[j]));

            if (action)
            {
              action.action(result, action.field, props[j], contextPath);
            }
            else
            {
              result[$.pincette.util.dom.getLocalName(props[j])] =
                $.pincette.util.dom.getText(props[j]);
            }
          }
        }
        else
        {
          if (!result.errors)
          {
            result.errors = [];
          }

          result.errors.push(createError(propstats[i], method));
        }
      }

      if
      (
        result.isCollection					&&
        result.href.charAt(result.href.length - 1) != '/'
      )
      {
        result.href += '/';
      }

      result.stableHref = getStableHref(result, contextPath);

      if (result.getlastmodified)
      {
        result.getlastmodified =
          $.pincette.util.parseHttpDate(result.getlastmodified);
      }

      return result;
    }



    function readSupportedMethodSet(response, field, supportedMethodSet)
    {
      var result = [];
      var supportedMethods =
        $.pincette.util.dom.selectElements
        (
          supportedMethodSet,
          'supported-method',
          $.pincette.webdav.dav
        );

      for (var i = 0; i < supportedMethods.length; ++i)
      {
        result.push(supportedMethods[i].getAttribute('name'));
      }

      response[field] = result;
    }



    function resolveUrl(baseUrl, url)
    {
      var result =
        $.pincette.util.url.resolveUrl(baseUrl, url.replace(/&/g, '%26'));
                                                          // Hack for browsers.

      result =
        result.charAt(0) == '/' ?
          result :
          (
            $.pincette.util.url.isUrl(result) ?
              $.pincette.util.url.
                encodeUriPath($.pincette.util.url.getParts(result).path) :
              result
          );

      return result;
    }



    $.pincette.webdav.Client = function()
    {
      this._chain = null;
      this._chainIsRunning = false;
    };



    $.pincette.webdav.Client = function(oauth, oauthFailure)
    {
      this._chain = null;
      this._chainIsRunning = false;
      this.oauth = $.isArray(oauth) ? new $.pincette.oauth.OAuth(oauth) : oauth;

      if (this.oauth && oauthFailure)
      {
        this.oauth.failure = oauthFailure;
      }
    };



    $.pincette.webdav.Client.prototype.acl =
      function(url, acl, success, failure)
    {
      var xhr =
        this.
          _operation(url, 'ACL', createAcl(acl), {}, [200], success, failure);

      return xhr;
    };



    $.pincette.webdav.Client.prototype.addLabel =
      function
      (
        url,
        label,
        depth,
        multiSuccess,
        multiFailure,
        success,
        failure,
        done
      )
    {
      var xhr =
        this._label
        (
          url,
          label,
          'add',
          depth,
          multiSuccess,
          multiFailure,
          success,
          failure,
          done
        );

      return xhr;
    };



    $.pincette.webdav.Client.prototype.applyAclToAll =
      function(url, acl, success, failure, done)
    {
      var dav = this;
      var forCollections = $.pincette.webdav.selectAcesForCollections(acl);
      var forDocuments = $.pincette.webdav.selectAcesForDocuments(acl);
      var xhr =
        this.forEach
        (
          url,
          [
            {namespaceURI: $.pincette.webdav.dav, localName: 'acl'},
            {namespaceURI: $.pincette.webdav.dav, localName: 'resourcetype'}
          ],
          null,
          function(responses)
          {
            dav.startChaining();

            for (var i = 0; i < responses.length; ++i)
            {
              if (!$.pincette.webdav.sameAcl(responses[i].acl, acl))
              {
                dav._acl(responses[i], acl, success, failure);
              }
            }

            dav.runChain
            (
              function()
              {
                if (done)
                {
                  done();
                }
              }
            );
          }
        );

      return xhr;
    };



    $.pincette.webdav.Client.prototype.audit =
      function(url, fields, success, failure)
    {
      var xhr =
        this._operation
        (
          $.pincette.util.url.getRootUrl(url),
          'AUDIT',
          createAudit(fields),
          {},
          [200],
          function(status, responseText)
          {
            if (success)
            {
              success
              (
                readEvents
                (
                  $.pincette.util.dom.selectElements
                  (
                    $.parseXML(responseText).documentElement,
                    'event',
                    $.pincette.webdav.re
                  )
                )
              );
            }
          },
          failure
        );

      return xhr;
    };



    $.pincette.webdav.Client.prototype.bind =
      function(url, newBinding, success, failure)
    {
      return this._bindOrRebind(url, newBinding, 'BIND', success, failure);
    };



    $.pincette.webdav.Client.prototype.checkIn =
      function(url, comment, propagate, success, failure, done)
    {
      var dav = this;

      function checkIn(url, comment, success, failure, response)
      {
        var xhr =
          dav._operation
          (
            url,
            'CHECKIN',
            null,
            {},
            [201],
            function(status, responseText, headers)
            {
              if (comment && headers.location && headers.location.length > 0)
              {
                dav.proppatch
                (
                  headers.location[0],
                  {comment: comment},
                  null,
                  function(response)
                  {
                    if (success)
                    {
                      response.href = url;
                      success(response);
                    }
                  },
                  failure
                );
              }
              else
              {
                if (success)
                {
                  if (response)
                  {
                    success(response);
                  }
                  else
                  {
                    success(status, responseText, headers);
                  }
                }
              }
            },
            failure
          );
  
        return xhr;
      }

      if (propagate)
      {
        var xhr =
          this.forEach
          (
            url,
            [{namespaceURI: $.pincette.webdav.dav, localName: 'checked-out'}],
            null,
            function(responses)
            {
              dav.startChaining();

              for (var i = 0; i < responses.length; ++i)
              {
                if (responses[i].checkedOut)
                {
                  checkIn
                  (
                    responses[i].href,
                    comment,
                    success,
                    failure,
                    responses[i]
                  );
                }
              }

              dav.runChain();

              if (done)
              {
                done(responses);
              }
            }
          );

        return xhr;
      }

      return checkIn(url, comment, success, failure);
    };



    $.pincette.webdav.Client.prototype.checkOut =
      function(url, success, failure)
    {
      var xhr =
        this._operation(url, 'CHECKOUT', null, {}, [200], success, failure);

      return xhr;
    };



    $.pincette.webdav.Client.prototype.copy = function
    (
      source,
      destination,
      success,
      failure,
      multiSuccess,
      multiFailure,
      multiDone
    )
    {
      var xhr =
        this._copyOrMove
        (
          'COPY',
          source,
          destination,
          success,
          failure,
          multiSuccess,
          multiFailure,
          multiDone
        );

      return xhr;
    };



    $.pincette.webdav.Client.prototype.create =
      function(url, contentType, success, failure)
    {
      var xhr =
        this._operation
        (
          url,
          'PUT',
          null,
          contentType ? {'Content-Type': contentType} : {},
          [201],
          success,
          failure
        );

      return xhr;
    };



    $.pincette.webdav.Client.prototype.deleteUrl =
      function(url, success, failure)
    {
      return this._operation(url, 'DELETE', null, {}, [204], success, failure);
    };



    $.pincette.webdav.Client.prototype.expandGroups =
      function(principals, properties, done)
    {
      function addUsers(principals)
      {
        for (var i = 0; i < principals.length; ++i)
        {
          if (!principals[i].response.isCollection)
          {
            users[principals[i].value] = principals[i];
          }
        }
      }

      if (!done)
      {
        return true;
      }

      var users = {};

      this.startChaining();

      for (var i = 0; i < principals.length; ++i)
      {
        if
        (
          principals[i].response				&&
          principals[i].response.isCollection			&&
          $.pincette.util.url.isUrl(principals[i].value)
        )
        {
          this.getPrincipals
          (
            principals[i].value,
            properties, 
            addUsers,
            function(){},
            'infinity'
          );
        }
        else
        {
          users[principals[i].value] = principals[i];
        }
      }

      this.runChain
      (
        function()
        {
          var result = [];

          for (var value in users)
          {
            if (users.hasOwnProperty(value))
            {
              result.push(users[value]);
            }
          }

          done(result);
        }
      );
    };



    $.pincette.webdav.Client.prototype.exists =
      function(url, success, failure)
    {
      var xhr =
        this.getProperties
        (
          url,
          [{namespaceURI: $.pincette.webdav.dav, localName: 'displayname'}],
          success,
          null,
          function(status, text, headers, method)
          {
            if (status == 404 && success)
            {
              success(null);
            }
            else
            {
              this._reportFailure(status, text, headers, method, url, failure);
            }
          }
        );

      return xhr;
    };



    $.pincette.webdav.Client.prototype.forEach =
      function(url, properties, action, done)
    {
      var responses = [];
      var xhr =
        this.propfind
        (
          url,
          properties ?
            properties :
            [{namespaceURI: $.pincette.webdav.dav, localName: 'displayname'}],
          'infinity',
          true,
          function(response)
          {
            responses.push(response);

            if (action)
            {
              action(response);
            }
          },
          null,
          function()
          {
            if (done)
            {
              done(responses);
            }
          }
        );

      return xhr;
    };



    $.pincette.webdav.Client.prototype.get = function(url, success, failure)
    {
      return this._operation(url, 'GET', null, {}, [200], success, failure);
    };



    $.pincette.webdav.Client.prototype.getAcl =
      function(url, success, multiFailure, failure)
    {
      var xhr =
        this.getProperties
        (
          url,
          [{namespaceURI: $.pincette.webdav.dav, localName: 'acl'}],
          success ? function(response){success(response.acl);} : null,
          multiFailure,
          failure
        );

      return xhr;
    };



    $.pincette.webdav.Client.prototype.getAllBindings =
      function(url, success, multiFailure, failure)
    {
      var xhr =
        this.getProperties
        (
          url,
          [{namespaceURI: $.pincette.webdav.dav, localName: 'parent-set'}],
          success ? function(response){success(response.bindings);} : null,
          multiFailure,
          failure
        );

      return xhr;
    };



    $.pincette.webdav.Client.prototype.getCheckedIn =
      function(url, depth, success, failure)
    {
      var contextPath = this.contextPath;

      return this.report
        (
          url,
          createCheckedIn(),
          depth,
          function(status, responseText)
          {
            if (status === 207 && (success || failure))
            {
              processMultistatus
              (
                url,
                responseText,
                'REPORT',
                true,
                contextPath,
                success,
                failure
              );
            }
          }
        );
    };



    $.pincette.webdav.Client.prototype.getCurrentUser =
      function(url, success, multiFailure, failure)
    {
      function getUser(url)
      {
        client.getProperties
        (
          url,
          [
            {namespaceURI: $.pincette.webdav.re, localName: 'bookmarks'},
            {namespaceURI: $.pincette.webdav.dav, localName: 'displayname'},
            {namespaceURI: $.pincette.webdav.re, localName: 'backup'},
            {namespaceURI: $.pincette.webdav.re, localName: 'email'},
            {namespaceURI: $.pincette.webdav.re, localName: 'home'},
            {namespaceURI: $.pincette.webdav.re, localName: 'language'},
            {namespaceURI: $.pincette.webdav.re, localName: 'meta'},
            {namespaceURI: $.pincette.webdav.re, localName: 'timezone'}
          ],
          success ? function(response){success(response);} : null,
          multiFailure,
          failure
        );
      }

      var client = this;
      var xhr =
        this.getProperties
        (
          url,
          [
            {
              namespaceURI: $.pincette.webdav.dav,
              localName: 'current-user-principal'
            }
          ],
          function(response)
          {
            if (response.currentUserPrincipal)
            {
              getUser(response.currentUserPrincipal);
            }
          },
          function(){getUser(resolveUrl(url, 'users/me'));}
        );

      return xhr;
    };



    $.pincette.webdav.Client.prototype.getDefaultFailure = function()
    {
      return this.defaultFailure;
    };



    $.pincette.webdav.Client.prototype.getGroups = function
    (
      rootUrl,
      contextPath,
      properties,
      done,
      includeSynthetic,
      includeOnlyReadable
    )
    {
      var result = [];
      var xhr =
        this.propfind
        (
          $.pincette.webdav.getRealUrl(rootUrl, contextPath, '/groups/'),
          (properties ? properties : []).concat
          (
            [
              {namespaceURI: $.pincette.webdav.dav, localName: 'displayname'},
              {
                namespaceURI: $.pincette.webdav.dav,
                localName: 'current-user-privilege-set'
              },
              {namespaceURI: $.pincette.webdav.dav, localName: 'resourcetype'}
                // To distinguish between groups and users. A group is a
                // collection.
            ]
          ),
          '1',
          false,
          function(response)
          {
            if
            (
              !includeOnlyReadable                                          ||
              (
                response.privileges                                         &&
                $.pincette.webdav.hasPrivilege(response.privileges, 'read')
              )
            )
            {
              result.push
              (
                new $.pincette.webdav.Principal
                (
                  response.displayname,
                  response.href,
                  response
                )
              );
            }
          },
          null,
          function()
          {
            done
            (
              includeSynthetic ?
                result.concat
                (
                  [
                    new $.pincette.webdav.Principal(getResource('all'), 'all'),
                    new $.pincette.webdav.Principal
                    (
                      getResource('authenticated'),
                      'authenticated'
                    )
                  ]
                ) : result
            );
          }
        );

      return xhr;
    };



    $.pincette.webdav.Client.prototype.getHome =
      function(url, success, multiFailure, failure)
    {
      var xhr =
        this.getProperties
        (
          url,
          [{namespaceURI: $.pincette.webdav.re, localName: 'home'}],
          success ? function(response){success(response.home);} : null,
          multiFailure,
          failure
        );

      return xhr;
    };



    $.pincette.webdav.Client.prototype.getMetaData =
      function(url, multiSuccess, multiFailure, failure)
    {
      var xhr =
        this.getProperties
        (
          url,
          [{namespaceURI: $.pincette.webdav.re, localName: 'meta'}],
          multiSuccess,
          multiFailure,
          failure
        );

      return xhr;
    };



    $.pincette.webdav.Client.prototype.getNames =
      function(collection, success, multiFailure, failure)
    {
      var result = [];
      var xhr =
        this.propfind
        (
          collection,
          [{namespaceURI: $.pincette.webdav.dav, localName: 'displayname'}],
          '1',
          false,
          function(response)
          {
            result.push($.pincette.util.getLastPathSegment(response.href));
          },
          multiFailure,
          success ? function(){success(result);} : null,
          failure
        );

      return xhr;
    };



    $.pincette.webdav.Client.prototype.getPreviewSet =
      function(url, multiSuccess, multiFailure, failure)
    {
      var xhr =
        this.getProperties
        (
          url,
          [{namespaceURI: $.pincette.webdav.dav, localName: 'preview-set'}],
          multiSuccess,
          multiFailure,
          failure
        );

      return xhr;
    };



    $.pincette.webdav.Client.prototype.getPrincipals =
      function(collection, properties, success, failure, depth)
    {
      var result = [];
      var xhr =
        this.propfind
        (
          collection,
          (properties ? properties : []).concat
          (
            [{namespaceURI: $.pincette.webdav.dav, localName: 'displayname'}]
          ),
          depth ? depth : '1',
          false,
          function(response)
          {
            result.push
            (
              new $.pincette.webdav.Principal
              (
                response.displayname,
                response.href,
                response
              )
            );
          },
          failure,
          success ? function(){success(result);} : null
        );

      return xhr;
    };



    $.pincette.webdav.Client.prototype.getProperties =
      function(url, properties, multiSuccess, multiFailure, failure)
    {
      var xhr =
        this.propfind
        (
          url,
          properties,
          '0',
          true,
          multiSuccess,
          multiFailure,
          null,
          failure
        );

      return xhr;
    };



    $.pincette.webdav.Client.prototype.getUsers =
      function(rootUrl, contextPath, properties, done)
    {
      var xhr =
        this.getPrincipals
        (
          $.pincette.webdav.getRealUrl(rootUrl, contextPath, '/users/'),
          properties,
          function(users){done(users);}
        );

      return xhr;
    };



    $.pincette.webdav.Client.prototype.getVersions =
      function(url, properties, success, failure, loaded)
    {
      var contextPath = this.contextPath;
      var xhr =
        this.report
        (
          url,
          createVersionRequest(properties),
          '0',
          function(status, responseText)
          {
            if (success || failure)
            {
              processVersionSet
              (
                url,
                responseText,
                contextPath,
                success,
                failure
              );
            }
  
            if (loaded)
            {
              loaded();
            }
          }
        );

      return xhr;
    };



    $.pincette.webdav.Client.prototype.getWorkflow =
      function(url, success, failure)
    {
      var xhr =
        this._operation
        (
          url + '?type=application%2fvnd.pincette.workflow%2bxml',
          'GET',
          null,
          {},
          [200],
          function(status, data, headers)
          {
            if
            (
              success					&&
              headers['content-type'] ==
                'application/vnd.pincette.workflow+xml'
            )
            {
              var result = [];

              $('step', $.parseXML(data).documentElement).each
              (
                function()
                {
                  result.push
                  (
                    {
                      id: $(this).attr('id'),
                      assignedUser: $('assigned-user', $(this)).text(),
                      status: $('status', $(this)).text()
                    }
                  );
                }
              );

              success(result);
            }
          },
          failure
        );

      return xhr;
    };



    $.pincette.webdav.Client.prototype.listFolder =
      function(url, properties, success, failure)
    {
      var responses = [];
      var xhr =
        this.propfind
        (
          url,
          properties,
          '1',
          false,
          function(response)
          {
            responses.push(response);
          },
          null,
          function(){success(responses);},
          failure
        );

      return xhr;
    };



    $.pincette.webdav.Client.prototype.lock =
      function(url, timeoutInSeconds, success, failure)
    {
      var xhr =
        this._operation
        (
          url,
          'LOCK',
          createLockinfo(),
          {
            Timeout:
              timeoutInSeconds && timeoutInSeconds > 0 ?
                ('Second-' + String(timeoutInSeconds)) : 'Infinite'
          },
          [200],
          function(status, responseText)
          {
            if (success)
            {
              success
              (
                readLockdiscoveryNode
                (
                  $.pincette.util.dom.selectFirstElement
                  (
                    $.parseXML(responseText).documentElement,
                    'lockdiscovery',
                    $.pincette.webdav.dav
                  )
                )
              );
            }
          },
          failure
        );

      return xhr;
    };



    $.pincette.webdav.Client.prototype.mkcol = function(url, success, failure)
    {
      var xhr =
        this._operation(url, 'MKCOL', null, {}, [201], success, failure);

      return xhr;
    };



    $.pincette.webdav.Client.prototype.mkcols = function(url, success, failure)
    {
      return this._mkcols(url, url, null, failure, success);
    };



    $.pincette.webdav.Client.prototype.move = function
    (
      source,
      destination,
      success,
      failure,
      multiSuccess,
      multiFailure,
      multiDone
    )
    {
      var xhr =
        this._copyOrMove
        (
          'MOVE',
          source,
          destination,
          success,
          failure,
          multiSuccess,
          multiFailure,
          multiDone
        );

      return xhr;
    };



    $.pincette.webdav.Client.prototype.propagateAcl =
      function(url, changes, success, failure, done)
    {
      var dav = this;
      var forCollectionsAdded =
        $.pincette.webdav.selectAcesForCollections(changes.added);
      var forCollectionsDeleted =
        $.pincette.webdav.selectAcesForCollections(changes.deleted);
      var forDocumentsAdded =
        $.pincette.webdav.selectAcesForDocuments(changes.added);
      var forDocumentsDeleted =
        $.pincette.webdav.selectAcesForDocuments(changes.deleted);
      var xhr =
        this.forEach
        (
          url,
          [
            {namespaceURI: $.pincette.webdav.dav, localName: 'acl'},
            {namespaceURI: $.pincette.webdav.dav, localName: 'resourcetype'}
          ],
          null,
          function(responses)
          {
            dav.startChaining();

            for (var i = 0; i < responses.length; ++i)
            {
              var newAcl =
                $.pincette.util.applyChanges
                (
                  responses[i].acl,
                  responses[i].isCollection ?
                    {
                      added: forCollectionsAdded,
                      deleted: forCollectionsDeleted
                    } :
                    {added: forDocumentsAdded, deleted: forDocumentsDeleted}
                );

              if (!$.pincette.webdav.sameAcl(responses[i].acl, newAcl))
              {
                dav._acl(responses[i], newAcl, success, failure);
              }
            }

            dav.runChain
            (
              function()
              {
                if (done)
                {
                  done();
                }
              }
            );
          }
        );

      return xhr;
    };



    $.pincette.webdav.Client.prototype.propfind =
      function
      (
        url,
        properties,
        depth,
        includeCollection,
        multiSuccess,
        multiFailure,
        loaded,
        failure
      )
    {
      var contextPath = this.contextPath;
      var xhr =
        this._operation
        (
          url,
          'PROPFIND',
          createPropfind(properties),
          {Depth: depth},
          [207],
          function(status, responseText)
          {
            if (multiSuccess || multiFailure)
            {
              processMultistatus
              (
                url,
                responseText,
                'PROPFIND',
                depth == '0' || includeCollection,
                contextPath,
                multiSuccess,
                multiFailure
              );
            }
  
            if (loaded)
            {
              loaded();
            }
          },
          failure
        );

      return xhr;
    };



    $.pincette.webdav.Client.prototype.proppatch =
      function
      (
        url,
        properties,
        lockToken,
        multiSuccess,
        multiFailure,
        failure,
        done
      )
    {
      var contextPath = this.contextPath;
      var xhr =
        this._operation
        (
          url,
          'PROPPATCH',
          createProppatch(properties),
          lockToken ? {'If': '(<' + lockToken + '>)'} : {},
          [207],
          function(status, responseText, headers)
          {
            if (multiSuccess || multiFailure)
            {
              processMultistatus
              (
                url,
                responseText,
                'PROPPATCH',
                true,
                contextPath,
                multiSuccess,
                multiFailure
              );
            }

            if (done)
            {
              done();
            }
          },
          failure
        );

      return xhr;
    };



    $.pincette.webdav.Client.prototype.put =
      function(url, body, headers, lockToken, success, failure)
    {
      if (lockToken)
      {
        if (!headers)
        {
          headers = {};
        }

        headers.If = '(<' + lockToken + '>)';
      }

      var xhr =
        this._operation
        (
          url,
          'PUT',
          body,
          headers,
          [200, 201, 204],
          success,
          failure
        );

      return xhr;
    };



    $.pincette.webdav.Client.prototype.rebind =
      function(url, newBinding, success, failure)
    {
      return this._bindOrRebind(url, newBinding, 'REBIND', success, failure);
    };



    $.pincette.webdav.Client.prototype.removeLabel =
      function
      (
        url,
        label,
        depth,
        multiSuccess,
        multiFailure,
        success,
        failure,
        done
      )
    {
      var xhr =
        this._label
        (
          url,
          label,
          'remove',
          depth,
          multiSuccess,
          multiFailure,
          success,
          failure,
          done
        );

      return xhr;
    };



    $.pincette.webdav.Client.prototype.report =
      function(url, body, depth, success, failure, poll)
    {
      var xhr =
        this._operation
        (
          url,
          'REPORT',
          body,
          depth ? {Depth: depth} : {},
          [200, 207],
          success,
          failure,
          poll
        );

      return xhr;
    };



    $.pincette.webdav.Client.prototype.runChain = function(done)
    {
      var dav = this;

      function end()
      {
        dav._chain = null;
        dav._chainIsRunning = false;

        if (dav._endActivity)
        {
          dav._endActivity();
        }

        if (done)
        {
          done();
        }
      }

      if (!this._chainIsRunning) // Nested chain call.
      {
        this._chainIsRunning = true;

        if (this._chain.length > 0)
        {
          this._runChainStep(this._chain, 0, end);
        }
        else
        {
          end();
        }
      }
    };



    $.pincette.webdav.Client.prototype.search =
      function
      (
        url,
        expressions,
        properties,
        multiSuccess,
        multiFailure,
        loaded,
        failure
      )
    {
      var contextPath = this.contextPath;
      var pattern = /<(\w+:)?response>.*?<\/(\w+:)?response>/m;
      var position = 0;
      var prefix = '';
      var startTag = null;
      var xhr =
        this.report
        (
          url,
          createSearch(expressions, properties),
          '0',
          loaded,
          failure,
          function(status, responseText)
          {
            if (multiSuccess || multiFailure)
            {
              if (startTag === null)
              {
                var result = /<(\w+:)?multistatus.*?>/.exec(responseText);

                if (result !== null)
                {
                  position = result[0].length;
                  startTag = result[0];

                  if (result.length > 1)
                  {
                    prefix = result[1];
                  }
                }
              }

              var response;

              while
              (
                (response = pattern.exec(responseText.substring(position))) !==
                  null
              )
              {
                position += response[0].length;

                processResponse
                (
                  url,
                  $.pincette.util.dom.selectFirstElement
                  (
                    $.parseXML
                    (
                      startTag + response[0] + '</' + prefix + 'multistatus>'
                    ).documentElement,
                    'response',
                    $.pincette.webdav.dav
                  ),
                  'REPORT',
                  true,
                  contextPath,
                  multiSuccess,
                  multiFailure
                );
              }
            }
          }
        );

      return xhr;
    };



    $.pincette.webdav.Client.prototype.setContextPath = function(contextPath)
    {
      this.contextPath = contextPath;
    };



    $.pincette.webdav.Client.prototype.setDefaultFailure = function(failure)
    {
      this.defaultFailure = failure;
    };



    $.pincette.webdav.Client.prototype.setEndActivity = function(fn)
    {
      var dav = this;

      this._endActivity = fn;

      this._ajaxCompleteHandler = function()
      {
        if (dav._chain === null && dav._endActivity)
        {
          dav._endActivity();
        }
      };

      ajaxCompleteHandlers.push(this._ajaxCompleteHandler);
    };



    $.pincette.webdav.Client.prototype.setLabel =
      function
      (
        url,
        label,
        depth,
        multiSuccess,
        multiFailure,
        success,
        failure,
        done
      )
    {
      var xhr =
        this._label
        (
          url,
          label,
          'set',
          depth,
          multiSuccess,
          multiFailure,
          success,
          failure,
          done
        );

      return xhr;
    };



    $.pincette.webdav.Client.prototype.setStartActivity = function(fn)
    {
      var dav = this;

      this._startActivity = fn;

      this._ajaxSendHandler = function()
      {
        if (dav._chain === null && dav._startActivity)
        {
          dav._startActivity();
        }
      };

      ajaxSendHandlers.push(this._ajaxSendHandler);
    };



    $.pincette.webdav.Client.prototype.startChaining = function()
    {
      if (this._chain === null)
      {
        this._chain = [];

        if (this._startActivity)
        {
          this._startActivity();
        }
      }
    };



    $.pincette.webdav.Client.prototype.unbind =
      function(url, success, failure)
    {
      var xhr =
        this._operation
        (
          $.pincette.util.getParent(url),
          'UNBIND',
          createBind('unbind', $.pincette.util.getLastPathSegment(url), null),
          {},
          [200, 204],
          success,
          failure
        );

      return xhr;
    };



    $.pincette.webdav.Client.prototype.uncheckOut =
      function(url, success, failure)
    {
      var xhr =
        this._operation(url, 'UNCHECKOUT', null, {}, [200], success, failure);

      return xhr;
    };



    $.pincette.webdav.Client.prototype.unlock =
      function(url, token, success, failure)
    {
      var xhr =
        this._operation
        (
          url,
          'UNLOCK',
          null,
          {'Lock-Token': '<' + token + '>'},
          [204],
          success,
          failure
        );

      return xhr;
    };



    $.pincette.webdav.Client.prototype.unsetEndActivity = function()
    {
      var dav = this;

      this._endActivity = null;

      ajaxCompleteHandlers.splice
      (
        $.pincette.util.
          indexOf(ajaxCompleteHandlers, this._ajaxCompleteHandler),
        1
      );
    };



    $.pincette.webdav.Client.prototype.unsetStartActivity = function()
    {
      var dav = this;

      this._startActivity = null;

      ajaxSendHandlers.splice
      (
        $.pincette.util.indexOf(ajaxSendHandlers, this._ajaxSendHandler),
        1
      );
    };



    $.pincette.webdav.Client.prototype._acl =
      function(response, acl, success, failure)
    {
      var xhr =
        this.acl
        (
          response.href,
          acl,
          function()
          {
            if (success)
            {
              success(response);
            }
          },
          function(status, text, method)
          {
            if (failure)
            {
              failure
              (
                response,
                $.pincette.webdav.ui.getStatusMessage(status, method, text)
              );
            }

            return true;
          }
        );

      return xhr;
    };



    $.pincette.webdav.Client.prototype._bindOrRebind =
      function(url, newBinding, operation, success, failure)
    {
      var xhr =
        this._operation
        (
          $.pincette.util.getParent(newBinding),
          operation,
          createBind
          (
            operation.toLowerCase(),
            $.pincette.util.getLastPathSegment(newBinding),
            url
          ),
          {},
          [200, 201, 204],
          success,
          failure
        );

      return xhr;
    };



    $.pincette.webdav.Client.prototype._copyOrMove = function
    (
      method,
      source,
      destination,
      success,
      failure,
      multiSuccess,
      multiFailure,
      multiDone
    )
    {
      var contextPath = this.contextPath;
      var xhr =
        this._operation
        (
          source,
          method,
          null,
          {
            Depth: 'infinity',
            Destination: destination,
            Overwrite: method == 'COPY' ? 'T' : 'F'
          },
          [201, 204, 207],
          function(status, responseText, headers)
          {
            if (status === 207)
            {
              if (multiSuccess || multiFailure)
              {
                processMultistatus
                (
                  source,
                  responseText,
                  method,
                  false,
                  contextPath,
                  multiSuccess,
                  multiFailure
                );
              }

              if (multiDone)
              {
                multiDone();
              }
            }
            else
            {
              if (success)
              {
                success(status, responseText, headers);
              }
            }
          },
          failure
        );

      return xhr;
    };



    $.pincette.webdav.Client.prototype._label =
      function
      (
        url,
        label,
        operation,
        depth,
        multiSuccess,
        multiFailure,
        success,
        failure,
        done
      )
    {
      var contextPath = this.contextPath;
      var xhr =
        this._operation
        (
          url,
          'LABEL',
          createLabel(label, operation),
          {Depth: depth},
          [200, 207],
          function(status, responseText, headers)
          {
            if (status == 207 && (multiSuccess || multiFailure))
            {
              processMultistatus
              (
                url,
                responseText,
                'LABEL',
                true,
                contextPath,
                multiSuccess,
                multiFailure
              );

              if (done)
              {
                done();
              }
            }
            else
            {
              if (status == 200 && success)
              {
                success(status, responseText, headers);
              }
            }
          },
          failure
        );

      return xhr;
    };



    $.pincette.webdav.Client.prototype._mkcols =
      function(originalUrl, url, success, failure, done)
    {
      function next(status, responseText, headers)
      {
        if (url == originalUrl)
        {
          done(status, responseText, headers);
        }
        else
        {
          if (success)
          {
            success(status, responseText, headers);
          }
        }
      }

      var dav = this;
      var xhr =
        dav.exists
        (
          url,
          function(response)
          {
            if (response === null)
            {
              var parent = $.pincette.util.getParent(url);
  
              if
              (
                parent.length > 1				&&
                (
                  parent.charAt(0) == '/'			||
                  $.pincette.util.url.isUrl(parent)
                )
              )
              {
                dav._mkcols
                (
                  originalUrl,
                  parent,
                  function()
                  {
                    dav.mkcol(url, next, failure);
                  },
                  failure
                );
              }
              else
              {
                dav.mkcol(url, next, failure);
              }
            }
            else
            {
              next(response);
            }
          },
          failure
        );

      return xhr;
    };



    $.pincette.webdav.Client.prototype._operation =
      function(url, method, body, headers, expected, success, failure, poll)
    {
      if (this._chain)
      {
        this._chain.push
        (
          {
            body: body,
            expected: expected,
            failure: failure ? failure : this.defaultFailure,
            headers: headers,
            method: method,
            success: success,
            url: url
          }
        );

        return null;
      }

      var result =
        this._runAjax
        (
          url,
          method,
          body,
          headers,
          expected,
          success,
          failure,
          poll
        );

      return result;
    };



    $.pincette.webdav.Client.prototype._reportFailure =
      function(status, text, headers, method, url, failure)
    {
      if (failure)
      {
        failure(status, text, method, headers, url);
      }
      else
      {
        if (this.defaultFailure)
        {
          this.defaultFailure(status, text, method, headers, url);
        }
        else
        {
          alert('Status: ' + status);
        }
      }
    };



    $.pincette.webdav.Client.prototype._runAjax =
      function(url, method, body, headers, expected, success, failure, poll)
    {
      function isExpected(jqXHR)
      {
        for (var i = 0; i < expected.length; ++i)
        {
          if (jqXHR.status == expected[i])
          {
            return true;
          }
        }

        return false;
      }

      if
      (
        (
          method == 'REPORT'		||
          method == 'AUDIT'
        )				&&
        $.browser.msie			&&
        $.browser.version == '8.0'
      )
      {
        headers['X-be.re.Real-Method'] = method;
        method = 'POST';
      }

      headers['Accept-Language'] = $.pincette.util.getLocale();

      var parameters = $.pincette.util.url.getParameters(location.href);

      if (parameters.onbehalfof)
      {
        headers['X-be.re.On-Behalf-Of'] = parameters.onbehalfof[0];
      }

      var client = this;
      var finished = false;
      var options =
        {
          dataType: 'text',
          type: method,
          headers: headers,
          beforeSend:
            function(jqXHR, settings)
            {
              if (client.oauth)
              {
                client.oauth.setAccessToken(jqXHR, settings);
              }
            },
          success:
            function(data, textStatus, jqXHR)
            {
              finished = true;

              if (isExpected(jqXHR))
              {
                var headers = getHeaders(xhr);

                if (poll)
                {
                  poll(jqXHR.status, data, headers);
                }

                if (success)
                {
                  success(jqXHR.status, data, headers);
                }
              }
              else
              {
                client._reportFailure
                (
                  jqXHR.status,
                  data,
                  getHeaders(xhr),
                  method,
                  url,
                  failure
                );
              }
            },
          error:
            function(jqXHR, textStatus, errorThrown)
            {
              finished = true;

              client._reportFailure
              (
                jqXHR.status,
                errorThrown,
                null,
                method,
                url,
                failure
              );
            },
          progress:
            function(e)
            {
              if (poll && isExpected(this))
              {
                if (client._endActivity)
                {
                  client._endActivity();
                }

                poll
                (
                  this.status,
                  this.responseText,
                  getHeaders(this)
                );
              }
            }
        };
      var xhr;

      if (body)
      {
        options.data = body;
      }

      function run()
      {
        xhr = $.ajax(url, options);

        return xhr;
      }

      if (client.oauth && !client.oauth.isPrepared())
      {
        client.oauth.prepareAccessTokens(run);

        return null;
      }

      return run();
    };



    $.pincette.webdav.Client.prototype._runChainStep =
      function(chain, position, done)
    {
      function next(status, responseText, headers)
      {
        if (position < chain.length - 1)
        {
          client._runChainStep(chain, position + 1, done);
        }
        else
        {
          done();
        }
      }

      if (position < chain.length)
      {
        var client = this;

        this._runAjax
        (
          chain[position].url,
          chain[position].method,
          chain[position].body,
          chain[position].headers,
          chain[position].expected,
          function(status, responseText, headers)
          {
            if (chain[position].success)
            {
              chain[position].success(status, responseText, headers);
            }

            next();
          },
          function(status, responseText, method, headers, url)
          {
            if
            (
              chain[position].failure					&&
              chain[position].
                failure(status, responseText, method, headers, url)
            )
            {
              next();
            }
            else
            {
              done();
            }
          }
        );
      }
    };



    $.pincette.webdav.Principal = function(displayname, value, response)
    {
      this.displayname = displayname;
      this.name = decodeURIComponent($.pincette.util.getLastPathSegment(value));
      this.value = value;
      this.response = response;
    };



    $.pincette.webdav.Principal.prototype.equals = function(other)
    {
      return other.value && other.value == this.value;
    };



    $.pincette.webdav.Principal.prototype.getDisplayname = function()
    {
      return this.displayname;
    };



    $.pincette.webdav.Principal.prototype.getValue = function()
    {
      return this.value;
    };



    $.pincette.webdav.Principal.prototype.setDisplayname = function(displayname)
    {
      this.displayname = displayname;
    };



    $.pincette.webdav.Principal.prototype.setValue = function(value)
    {
      this.value = value;
    };



    $.pincette.webdav.Principal.prototype.toString = function()
    {
      return this.displayname;
    };



    $.pincette.webdav.canUpdate = function(response)
    {
      var result =
        !response.autoVersion || response.checkedOut ||
          response.autoVersion == 'checkout-checkin' ||
          response.autoVersion == 'checkout-unlocked-checkin' ||
          response.autoVersion == 'checkout' ||
          response.autoVersion == 'filesystem';

      return result;
    };



    $.pincette.webdav.createAces = function(principals, privilege)
    {
      var result = new Array(principals.length);

      for (var i = 0; i < principals.length; ++i)
      {
        result[i] = {};
        result[i].protected = false;
        result[i].invert = false;
        result[i].grant = true;
        result[i].principal = principals[i];
        result[i].privilege = privilege;
      }

      return result;
    };



    $.pincette.webdav.getClosestPreview = function(response, minWidth)
    {
      var result = null;

      if (response.previews)
      {
        for (var i = 0; i < response.previews.length; ++i)
        {
          if
          (
            result === null                                               ||
            (
              Number(response.previews[i].width) >= minWidth              &&
              (
                Math.abs(minWidth - Number(response.previews[i].width)) <
                  Math.abs(minWidth - Number(result.width))               ||
                Number(result.width) < minWidth
              )
            )
          )
          {
            result = response.previews[i];
          }
        }
      }

      return result;
    };



    $.pincette.webdav.getElementOrTerm = function(url, contextPath)
    {
      var result =
        $.pincette.webdav.isProperty(url, contextPath) ?
          $.pincette.util.dc.getElementOrTerm
          (
            decodeURIComponent($.pincette.util.getLastPathSegment(url))
          ) : null;

      return result;
    };



    $.pincette.webdav.getLargestPreview = function(response)
    {
      var result = null;

      if (response.previews)
      {
        for (var i = 0; i < response.previews.length; ++i)
        {
          if
          (
            result === null						||
            Number(response.previews[i].width) > Number(result.width)
          )
          {
            result = response.previews[i];
          }
        }
      }

      return result;
    };



    $.pincette.webdav.getMetaDataValue = function(response, name)
    {
      var result =
        response.meta && response.meta[name] && response.meta[name].length > 0 ?
          response.meta[name][0] : null;

      return result;
    };



    $.pincette.webdav.getPath = function(url, contextPath)
    {
      var path = $.pincette.util.url.getPath(url);
      var result =
        contextPath && $.pincette.util.startsWith(path, contextPath) ?
          path.substring(contextPath.length) : path;

      return result;
    };



    $.pincette.webdav.getPrincipalValues = function(principals)
    {
      var result = [];

      for (var i = 0; i < principals.length; ++i)
      {
        result.push(principals[i].value);
      }

      return result;
    };



    $.pincette.webdav.getRealUrl = function(rootUrl, contextPath, fullPath)
    {
      var result =
        $.pincette.util.
          stripTrailingSlash($.pincette.util.url.getRootUrl(rootUrl)) +
          (contextPath ? contextPath : "") + fullPath;

      return result;
    };



    $.pincette.webdav.getSmallestPreview = function(response)
    {
      var result = null;

      if (response.previews)
      {
        for (var i = 0; i < response.previews.length; ++i)
        {
          if
          (
            result === null						||
            Number(response.previews[i].width) < Number(result.width)
          )
          {
            result = response.previews[i];
          }
        }
      }

      return result;
    };



    $.pincette.webdav.getVersionName = function(versionUrl)
    {
      var index = versionUrl.indexOf('/act/');
      var result =
        index != -1 ?
          versionUrl.substring
          (
            index + 5,
            versionUrl.charAt(versionUrl.length - 1) == '/' ?
              versionUrl.length - 1 : versionUrl.length
          ) : null;

      return result;
    };



    $.pincette.webdav.getWorkflow = function(response)
    {
      if (response.referringTo)
      {
        for (var i = 0; i < response.referringTo.length; ++i)
        {
          if (response.referringTo[i].name == 'workflow')
          {
            return response.referringTo[i].href;
          }
        }
      }

      return null;
    };



    $.pincette.webdav.hasAllPrivileges = function(given, requested)
    {
      for (var i = 0; i < requested.length; ++i)
      {
        if (!$.pincette.webdav.hasPrivilege(given, requested[i]))
        {
          return false;
        }
      }

      return true;
    };



    $.pincette.webdav.hasPrivilege = function(given, requested)
    {
      for (var i = 0; i < given.length; ++i)
      {
        if (given[i] == requested || impliesPrivilege(given[i], requested))
        {
          return true;
        }
      }

      return false;
    };



    $.pincette.webdav.hasWorkflow = function(response)
    {
      return $.pincette.webdav.getWorkflow(response) !== null;
    };



    $.pincette.webdav.inGroups = function(url, contextPath)
    {
      var result =
        $.pincette.util.
          startsWith($.pincette.webdav.getPath(url, contextPath), '/groups/');

      return result;
    };



    $.pincette.webdav.inMeta = function(url, contextPath)
    {
      var result =
        $.pincette.util.
          startsWith($.pincette.webdav.getPath(url, contextPath), '/meta/');

      return result;
    };



    $.pincette.webdav.inMetaBrowse = function(url, contextPath)
    {
      var result =
        $.pincette.util.startsWith
        (
          $.pincette.webdav.getPath(url, contextPath),
          '/meta/browse/'
        );

      return result;
    };



    $.pincette.webdav.inMetaProperties = function(url, contextPath)
    {
      var result =
        $.pincette.util.startsWith
        (
          $.pincette.webdav.getPath(url, contextPath),
          '/meta/properties/'
        );

      return result;
    };



    $.pincette.webdav.inUsers = function(url, contextPath)
    {
      var result =
        $.pincette.util.
          startsWith($.pincette.webdav.getPath(url, contextPath), '/users/');

      return result;
    };



    $.pincette.webdav.isActivity = function(response)
    {
      return $.pincette.util.inArray(response.resourceTypes, 'activity');
    };



    $.pincette.webdav.isDocument = function(response)
    {
      return $.pincette.util.inArray(response.resourceTypes, 'document');
    };



    $.pincette.webdav.isGroups = function(url, contextPath)
    {
      return $.pincette.webdav.getPath(url, contextPath) == '/groups/';
    };



    $.pincette.webdav.isPrincipal = function(response)
    {
      return $.pincette.util.inArray(response.resourceTypes, 'principal');
    };



    $.pincette.webdav.isProperty = function(url, contextPath)
    {
      var segments =
        $.pincette.util.
          getPathSegments($.pincette.webdav.getPath(url, contextPath));
      var result =
        segments.length >= 3 && segments[0] == 'meta' &&
          (
            (segments.length == 3 && segments[1] == 'properties') ||
              (
                segments.length % 2 == 1 && segments[1] == 'browse' &&
                  url.charAt(url.length - 1) == '/'
              )
          );

      return result;
    };



    $.pincette.webdav.isPropertyValue = function(url, contextPath)
    {
      var segments =
        $.pincette.util.
          getPathSegments($.pincette.webdav.getPath(url, contextPath));
      var result =
        segments.length >= 4 && segments[0] == 'meta' &&
          (
            (segments.length == 4 && segments[1] == 'properties') ||
              (segments.length % 2 === 0 && segments[1] == 'browse')
          );

      return result;
    };



    $.pincette.webdav.isPureCollection = function(response, contextPath)
    {
      var result =
        response.isCollection &&
          !$.pincette.webdav.isSystemPath(response.href, contextPath) &&
          !$.pincette.webdav.isProperty(response.href, contextPath) &&
          !$.pincette.webdav.isPropertyValue(response.href, contextPath) &&
          !$.pincette.util.startsWith
          (
            $.pincette.webdav.getPath(response.href, contextPath),
            '/groups/'
          );

      return result;
    };



    $.pincette.webdav.isReservedPrincipal = function(name)
    {
      var result =
        name == 'all' || name == 'authenticated' || name == 'unauthenticated';

      return result;
    };



    $.pincette.webdav.isSystemPath = function(url, contextPath)
    {
      var path = $.pincette.webdav.getPath(url, contextPath);
      var result =
        path == '/act/' || path == '/groups/' || path == '/lost+found/' ||
          path == '/users/' || path == '/meta/' || path == '/meta/browse/' ||
          path == '/meta/properties/' || path == '/view/' ||
          path == '/view/default' || path == '/view/configuration' ||
          path == '/view/work' || path == '/act/main';

      return result;
    };



    $.pincette.webdav.isSystemUser = function(url, contextPath)
    {
      return $.pincette.webdav.getPath(url, contextPath) == '/users/system';
    };



    $.pincette.webdav.isTechnicalField = function(field)
    {
      var result =
        field == 'displayname' || field == 'getlastmodified' ||
          field == 'getcontenttype' || field == 'checked-out' ||
          field == 'getcontentlength';

      return result;
    };



    $.pincette.webdav.isTrash = function(url)
    {
      return $.pincette.util.getLastPathSegment(url) == '.Trash';
    };



    $.pincette.webdav.isUsers = function(url, contextPath)
    {
      return $.pincette.webdav.getPath(url, contextPath) == '/users/';
    };



    $.pincette.webdav.isView = function(response)
    {
      return $.pincette.util.inArray(response.resourceTypes, 'view');
    };



    $.pincette.webdav.removeAcesWithPrivilege = function(aces, privilege)
    {
      var result = [];

      for (var i = 0; i < aces.length; ++i)
      {
        if
        (
          aces[i].protected						||
          !aces[i].grant						||
          (
            aces[i].privilege.namespaceURI != $.pincette.webdav.dav	&&
            aces[i].privilege.namespaceURI != $.pincette.webdav.re
          )								||
          aces[i].privilege.namespaceURI != privilege.namespaceURI	||
          aces[i].privilege.localName != privilege.localName
        )
        {
          result.push(aces[i]);
        }
      }

      return result;
    };



    $.pincette.webdav.sameAcl = function(aces1, aces2)
    {
      if (aces1.length != aces2.length)
      {
        return false;
      }

      aces1 = $.pincette.util.copy(aces1, false);
      aces2 = $.pincette.util.copy(aces2, false);
      aces1.sort(compareAce);
      aces2.sort(compareAce);

      return $.pincette.util.arraysEqual(aces1, aces2);
    };



    $.pincette.webdav.selectAcesForCollections = function(aces)
    {
      var result = [];

      for (var i = 0; i < aces.length; ++i)
      {
        if
        (
          aces[i].privilege.namespaceURI != $.pincette.webdav.dav	||
          (
            aces[i].privilege.localName != 'write-contents'		&&
            aces[i].privilege.localName != 'write-properties'		&&
            aces[i].privilege.localName != 'unlock'
          )
        )
        {
          result.push($.pincette.util.copy(aces[i], true));
        }
      }

      return result;
    };



    $.pincette.webdav.selectAcesForDocuments = function(aces)
    {
      var result = [];

      for (var i = 0; i < aces.length; ++i)
      {
        if
        (
          aces[i].privilege.namespaceURI != $.pincette.webdav.dav	||
          (
            aces[i].privilege.localName != 'bind'			&&
            aces[i].privilege.localName != 'unbind'
          )
        )
        {
          var ace = $.pincette.util.copy(aces[i], true);

          if
          (
            ace.privilege.namespaceURI == $.pincette.webdav.re	&&
            ace.privilege.localName == 'write-documents'
          )
          {
            ace.privilege.namespaceURI = $.pincette.webdav.dav;
            ace.privilege.localName = 'write';
          }

          result.push(ace);
        }
      }

      return result;
    };



    $.pincette.webdav.selectWorkflowVersions = function(responses)
    {
      var result = [];

      for (var i = 0; i < responses.length; ++i)
      {
        if (responses[i].labels)
        {
          var found = false;

          for (var j = 0; j < responses[i].labels.length && !found; ++j)
          {
            if ($.pincette.util.startsWith(responses[i].labels[j], 'WORKFLOW_'))
            {
              found = true;
            }
          }

          if (found)
          {
            result.push(responses[i]);
          }
        }
      }

      return result;
    };



    $.pincette.webdav.ui.getErrorMessage = function(error)
    {
      var children = $.pincette.util.dom.selectElements(error);
      var message = '';

      for (var i = 0; i < children.length; ++i)
      {
        var localName = $.pincette.util.dom.getLocalName(children[i]);

        message +=
          '<div>' + $.pincette.webdav.ui.getPreconditionMessage(localName);

        if (localName == 'need-privileges')
        {
          var resources =
            $.pincette.util.dom.
              selectElements(children[i], 'resource', $.pincette.webdav.dav);

          for (var j = 0; j < resources.length; ++j)
          {
            var privileges =
              $.pincette.util.dom.selectElements
              (
                resources[j],
                'privilege',
                $.pincette.webdav.dav
              );

            message +=
              '<div>' +
                getUrlPath
                (
                  $.pincette.util.dom.getText
                  (
                    $.pincette.util.dom.selectFirstElement
                    (
                      resources[j],
                      'href',
                      $.pincette.webdav.dav
                    )
                  )
                ) + ': ';

            for (var k = 0; k < privileges.length; ++k)
            {
              message +=
                '<div>' +
                  $.pincette.webdav.ui.getPrivilegeDescription
                  (
                    $.pincette.util.dom.getLocalName
                    (
                      $.pincette.util.dom.selectFirstElement(privileges[k])
                    )
                  ) + '</div>';
            }

            message += '</div>';
          }
        }

        message += '</div>';
      }

      return message;
    };



    $.pincette.webdav.ui.getPreconditionMessage = function(precondition)
    {
      var map = $.pincette.util.perLanguage(preconditionMessages);

      return map[precondition];
    };



    $.pincette.webdav.ui.getPrivilegeDescription = function(privilege)
    {
      var map = $.pincette.util.perLanguage(privilegeDescriptions);

      return map[privilege];
    };



    $.pincette.webdav.ui.getStatusMessage =
      function(status, method, defaultText)
    {
      var map = $.pincette.util.perLanguage(httpStatusMessages);
      var message;

      if (method)
      {
        message = map[String(status) + '-' + method.toLowerCase()];
      }

      if (!message)
      {
        message = map[status];
      }

      if (!message)
      {
        message = defaultText ? defaultText : ('Status: ' + status);
      }

      return message;
    };



    $.pincette.webdav.ui.replaceData = function(element, response, fields, dav)
    {
      var data = $.pincette.util.copy(response, false);

      displayFieldsWithType(data, fields);

      if (response.href)
      {
        data.href =
          '<a href="' + response.href + '" target="_blank">' +
            $.pincette.util.url.displayUrl(response.href) + '</a>';
      }

      if (response.name)
      {
        data.name = $.pincette.util.addWrapPoints(response.name);
      }

      if (response.getcontentlength)
      {
        data.getcontentlength =
          $.pincette.util.ui.displaySize(response.getcontentlength);
      }

      if (response.owner)
      {
        data.owner = $.pincette.util.getLastPathSegment(response.owner);
      }

      displayMeta(data, response.meta, fields);

      var preview = getPreview(response);

      if (preview)
      {
        data.preview =
          '<img class="webdav-ui-preview" src="' + preview + '"></img>';
      }

      if (response.score)
      {
        data.score = Math.round(response.score * 100) + '%';
      }

      if (response.fragments)
      {
        data.fragments = response.fragments;
      }

      $('*', element).contents().
        filter(function(){return this.nodeType == 3;}).each
        (
          function()
          {
            var text = this.data;
            var textNode = this;

            this.data = ''; // Cleared to avoid brief appearance of parameters.

            lazyLoadRelations
            (
              response,
              text,
              data,
              function(data)
              {
                // This doesn't just update this.data because the replacement
                // can be an HTML string.

                try
                {
                  var parent = $(textNode).parent();

                  $(textNode).replaceWith
                  (
                    $.pincette.util.replaceParameters(text, data)
                  );

                  // This can also appear on blocks that handle click
                  // themselves.
                  $('.pincette-relation > span', parent).
                    click(function(e){e.stopImmediatePropagation();});
                }

                catch (e)
                {
                  // DOM errors are possible.
                }
              },
              dav
            );
          }
        );
    };



    $.pincette.webdav.ui.report =
      function(method, status, error, responseDescription)
    {
      var responseText =
        responseDescription ?
          $.pincette.util.dom.getText(responseDescription) : '';
      var result =
        error ?
          $.pincette.webdav.ui.getErrorMessage(error) :
          (
            responseText.length > 0 ?
              responseText :
              $.pincette.webdav.ui.getStatusMessage(status, method)
          );

      return result;
    };



    $.pincette.webdav.ui.sortPrincipals = function(principals)
    {
      principals.sort
      (
        function(p1, p2)
        {
          var result =
            p1.displayname.toLowerCase().
              localeCompare(p2.displayname.toLowerCase());

          return result;
        }
      );

      return principals;
    };
  }
)(jQuery);
